GNU logs - #32159, boring messages


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 00:23:01 +0000
Resent-Message-ID: <handler.32159.B.153161416420673 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: report 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 32159 <at> debbugs.gnu.org
X-Debbugs-Original-To: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.153161416420673
          (code B ref -1); Sun, 15 Jul 2018 00:23:01 +0000
Received: (at submit) by debbugs.gnu.org; 15 Jul 2018 00:22:44 +0000
Received: from localhost ([127.0.0.1]:60368 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1feUoF-0005NN-TA
	for submit <at> debbugs.gnu.org; Sat, 14 Jul 2018 20:22:44 -0400
Received: from eggs.gnu.org ([208.118.235.92]:41391)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1feUVA-0004uL-Nb
 for submit <at> debbugs.gnu.org; Sat, 14 Jul 2018 20:03:01 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <moses.mason@HIDDEN>) id 1feUV4-0005y0-Ic
 for submit <at> debbugs.gnu.org; Sat, 14 Jul 2018 20:02:55 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:51686)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <moses.mason@HIDDEN>)
 id 1feUV4-0005xl-FR
 for submit <at> debbugs.gnu.org; Sat, 14 Jul 2018 20:02:54 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:60593)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <moses.mason@HIDDEN>) id 1feUV3-0008Bf-5j
 for bug-gnu-emacs@HIDDEN; Sat, 14 Jul 2018 20:02:54 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <moses.mason@HIDDEN>) id 1feUV2-0005wB-5a
 for bug-gnu-emacs@HIDDEN; Sat, 14 Jul 2018 20:02:53 -0400
Received: from mail-wr1-x435.google.com ([2a00:1450:4864:20::435]:33509)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <moses.mason@HIDDEN>)
 id 1feUV1-0005vU-UV
 for bug-gnu-emacs@HIDDEN; Sat, 14 Jul 2018 20:02:52 -0400
Received: by mail-wr1-x435.google.com with SMTP id g6-v6so19515155wrp.0
 for <bug-gnu-emacs@HIDDEN>; Sat, 14 Jul 2018 17:02:51 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=N1C/ecV1uvOt4RMHCyiJW6v7CR0c3lxcSrLzuIuV0UE=;
 b=IcFnu+qUU/oMqu7zNEzHgycGJsmFs675j6Qn8UiZZnE8FZ8DQjHSYhtaoyI0w239Lo
 O9BWhcPFKQBJfozxM2POctIkI0R2UOXbT3Br9kVDLatuW+IsRRx39ih8mSvto8YYLNvN
 qp2TbQ4o3pD5cqIlgL6NDlXMKPHStYFKc3zobGL5nwjiHhhfM+LyokJ2aHj37H8NyARx
 qD90QpufGkq6WKyN73vUx2+EdQk+qn0aYMWspQpNm6jlZhoSShbacokzGd4AazhQA/N7
 ruxDWi8/riMTPmbLGkLSYWHlYP9qxWr+OgWjJpSK4CBM37Cz5RpKWhr9S9HiA+WkhYNV
 os8w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=N1C/ecV1uvOt4RMHCyiJW6v7CR0c3lxcSrLzuIuV0UE=;
 b=YDgV0jF9AIrvTRDpZKeGc+07kTxwsj3cVZp7BjLr0ccS//FS33D1DzrpeDnIA5tuGc
 syWa7MVsa5bXwkmbqLCMAJSHSKRUcbYaQlfiW3BE/akkaI1b1nTqvNu37fESrYLLPeNe
 veSoGteF3mHJoGYrbFB405YyQjZxo/4SUYqbaTwuCxIqPZA2g6P8TMrSrmfWC1Vp75Mt
 /U7yf2JiwrAFAIew2HRpBQR24NZp0zj6tB+tXKVxM+onmgeXE0GrOP9lGRyATnQqPnKd
 FKgF3m38BClhrXmWQeOiRHEryFFaGTR23IHmsBF10/STxTrBASe2hG9IvEARMUDbCqrZ
 8xFA==
X-Gm-Message-State: AOUpUlF81oW9Jif8ZJZbpUhVziAj4zBC/30t5Z2GmRYtf3pLzF18eZ7I
 EEMZFhNFL681qQW0sPA6Cr5bXXXJ91yPJaFnNH1UUTWQ
X-Google-Smtp-Source: AAOMgpeZ9MiZ8YjhkBGbdOg6cMEtJtQmpyrO0uT6Zr49Bjwg8IogpAzkhwFGWoexKF7GCNrvoOn1OLLrFfHoNXWa360=
X-Received: by 2002:adf:9954:: with SMTP id
 x78-v6mr9016270wrb.178.1531612970268; 
 Sat, 14 Jul 2018 17:02:50 -0700 (PDT)
MIME-Version: 1.0
From: Moses <moses.mason@HIDDEN>
Date: Sun, 15 Jul 2018 00:02:13 +0000
Message-ID: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Mailman-Approved-At: Sat, 14 Jul 2018 20:22:42 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

For bug#24938, I have to set inhibit-compacting-font-caches to non-nil
[0] to fix the lagging issue. It fixes almost but not all the
problems. Lagging reappears when I opening a multi languages file
(e.g. M-x view-hello-file),  Emacs could become very very slow until
the file is completely opened.

This issue may need another fix.


In GNU Emacs 26.1 (build 1, x86_64-w64-mingw32)
 of 2018-05-30 built on CIRROCUMULUS
Repository revision: 07f8f9bc5a51f5aa94eb099f3e15fbe0c20ea1ea
Windowing system distributor 'Microsoft Corp.', version 10.0.17134

Configured using:
 'configure --without-dbus --host=x86_64-w64-mingw32
 --without-compress-install 'CFLAGS=-O2 -static -g3''

Configured features:
XPM JPEG TIFF GIF PNG RSVG SOUND NOTIFY ACL GNUTLS LIBXML2 ZLIB
TOOLKIT_SCROLL_BARS THREADS LCMS2

Important settings:
  value of $LANG: ENU
  locale-coding-system: cp936

Major mode: Fundamental

Minor modes in effect:
  erc-spelling-mode: t
  erc-netsplit-mode: t
  erc-services-mode: t
  erc-networks-mode: t
  erc-log-mode: t
  erc-stamp-mode: t
  erc-ring-mode: t
  tabbar-mwheel-mode: t
  tabbar-mode: t
  delete-selection-mode: t
  show-paren-mode: t
  display-time-mode: t
  auto-image-file-mode: t
  desktop-save-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t
  view-mode: t

Memory information:
((conses 16 689409 87539)
 (symbols 56 46936 1)
 (miscs 48 72 133)
 (strings 32 85086 25863)
 (string-bytes 1 1976295)
 (vectors 16 48121)
 (vector-slots 8 1152206 20738)
 (floats 8 237 89)
 (intervals 56 21696 8137)
 (buffers 992 16))

[0] https://lists.gnu.org/archive/html/bug-gnu-emacs/2016-11/msg00471.html




Message sent:


Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-Mailer: MIME-tools 5.505 (Entity 5.505)
Content-Type: text/plain; charset=utf-8
X-Loop: help-debbugs@HIDDEN
From: help-debbugs@HIDDEN (GNU bug Tracking System)
To: Moses <moses.mason@HIDDEN>
Subject: bug#32159: Acknowledgement (26.1; inhibit-compacting-font-caches
 does not fix all fonts lagging issue)
Message-ID: <handler.32159.B.153161416420673.ack <at> debbugs.gnu.org>
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
X-Gnu-PR-Message: ack 32159
X-Gnu-PR-Package: emacs
Reply-To: 32159 <at> debbugs.gnu.org
Date: Sun, 15 Jul 2018 00:23:02 +0000

Thank you for filing a new bug report with debbugs.gnu.org.

This is an automatically generated reply to let you know your message
has been received.

Your message is being forwarded to the package maintainers and other
interested parties for their attention; they will reply in due course.

Your message has been sent to the package maintainer(s):
 bug-gnu-emacs@HIDDEN

If you wish to submit further information on this problem, please
send it to 32159 <at> debbugs.gnu.org.

Please do not send mail to help-debbugs@HIDDEN unless you wish
to report a problem with the Bug-tracking system.

--=20
32159: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D32159
GNU Bug Tracking System
Contact help-debbugs@HIDDEN with problems


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 02:40:01 +0000
Resent-Message-ID: <handler.32159.B32159.153162238732747 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153162238732747
          (code B ref 32159); Sun, 15 Jul 2018 02:40:01 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 02:39:47 +0000
Received: from localhost ([127.0.0.1]:60391 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1feWwq-0008W3-RI
	for submit <at> debbugs.gnu.org; Sat, 14 Jul 2018 22:39:47 -0400
Received: from eggs.gnu.org ([208.118.235.92]:57844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1feWwp-0008Vq-Ff
 for 32159 <at> debbugs.gnu.org; Sat, 14 Jul 2018 22:39:43 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1feWwf-0004pt-4o
 for 32159 <at> debbugs.gnu.org; Sat, 14 Jul 2018 22:39:38 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.5 required=5.0 tests=BAYES_05 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:52506)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1feWwf-0004pS-18; Sat, 14 Jul 2018 22:39:33 -0400
Received: from [176.228.60.248] (port=3559 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1feWwe-0001bC-Io; Sat, 14 Jul 2018 22:39:32 -0400
Date: Sun, 15 Jul 2018 05:39:37 +0300
Message-Id: <83muut9q8m.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 (message from Moses on Sun, 15 Jul 2018 00:02:13 +0000)
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Sun, 15 Jul 2018 00:02:13 +0000
> 
> For bug#24938, I have to set inhibit-compacting-font-caches to non-nil
> [0] to fix the lagging issue. It fixes almost but not all the
> problems. Lagging reappears when I opening a multi languages file
> (e.g. M-x view-hello-file),  Emacs could become very very slow until
> the file is completely opened.

That lagging might have a valid reason: how many fonts do you have
installed?  What does (length (x-list-fonts "*")) return?

If you have many fonts, Emacs will search them all to find a suitable
one, and if some characters in HELLO don't have fonts, it will search
them several times.  That might take time.  If the lagging disappears
once you display the entire file, that is most probably the reason.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 05:52:02 +0000
Resent-Message-ID: <handler.32159.B32159.153163387218873 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153163387218873
          (code B ref 32159); Sun, 15 Jul 2018 05:52:02 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 05:51:12 +0000
Received: from localhost ([127.0.0.1]:60438 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1feZw8-0004uK-AY
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 01:51:12 -0400
Received: from mail-wm0-f51.google.com ([74.125.82.51]:38491)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1feZw6-0004u5-Lk
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 01:51:11 -0400
Received: by mail-wm0-f51.google.com with SMTP id 69-v6so12654293wmf.3
 for <32159 <at> debbugs.gnu.org>; Sat, 14 Jul 2018 22:51:10 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=ZokgoU5VuhSm2hQ3ssj65eC2ishuglbgNp1g9k083XM=;
 b=LVJ/khZrtLKk6rsac6u7bNu9BWdM9/bejO1TyzY5iOVvm8i6s1/jRV7DcPnYufenuX
 TKTnQKO7K3LPEXph7Jhaoi8M1tCX0hSNEwJg6RUeGpjIgqQm2IY4uVmpU8ImR/E7pHDr
 nBpRi3Ee6FHz61lIJ431ackpdJQmF6Z/X1SGNsHMqBTrm5JplF1kAIszvIIRRKyMzcCh
 fJvdiA7/kMaBR0BPQpaY0cZ+vltVWIPj266UIBaLl0sgDJB13YkNPBaJSnMmccxjI0D6
 TNkZE/HhJzBmOMNaJaHcmW1saVf4P4CfNCmXo1ZPlJSGqEXQMpT0k0WWrFAg4uh8dz1O
 /xBg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=ZokgoU5VuhSm2hQ3ssj65eC2ishuglbgNp1g9k083XM=;
 b=BM+3SGkYNJgy1rY9A6HqtqUWhnna0aqb8sXj7+ouLLrQo7ZXs0NHTo8O5xinIlWD49
 Hrz6GydKA6BFk/Gg+EMO8p7tVjz7G1fhk+pmNqo80hX3DN607aQXkdkOKSXRqJtz4M+P
 xeSX06k88+uIuzzkDT2QBfvQAkTSR1Kt/dxD3wxcdcYyEBQtZF/MHWIBtJrzG9JcA8vX
 Cs9JbIZXNcc/XshAJKbkV923vpuUpsCvoy8D8NzidowZghYM/2acwEJ30L3GGcnPs9YC
 JULDb6IfXWxEPSq3sNX5hxOuPPS8PVAfAwnw1ElvMfWW/HPvQkSL7pgx59UTlK7AzYpD
 c14Q==
X-Gm-Message-State: AOUpUlFk/v6hr303biuHvH+EDxIn9Tt1t3JwP2jyO3QlnbF9Hmbrc9kS
 TRRwIvvGR7PdBn90ewtMbUApJRHCyBGUzIz6jmk=
X-Google-Smtp-Source: AAOMgpfW5hNuFEMWE2/LkjpszbGUhxFLMRRZlHCyxLWrC7TFORjUuetB5aHeOkIEKbDnR5kUrk2DmnUUHaBPLeGi4Co=
X-Received: by 2002:a1c:570a:: with SMTP id
 l10-v6mr7419376wmb.56.1531633863929; 
 Sat, 14 Jul 2018 22:51:03 -0700 (PDT)
MIME-Version: 1.0
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
In-Reply-To: <83muut9q8m.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Sun, 15 Jul 2018 05:50:26 +0000
Message-ID: <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

You are right. I got 5906 installed fonts returned from (length
(x-list-fonts "*")). However, this still a problem, which is really
annoying when editing files that contain more than one language. Other
editor does not have the similar issue. I am not an expert, but as far
as I know, the font fallback link is already stored in the register
under key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows
NT\CurrentVersion\FontLink\SystemLink, why Emacs still needs to search
fonts multiple times?


On Sun, Jul 15, 2018 at 2:39 AM Eli Zaretskii <eliz@HIDDEN> wrote:
>
> > From: Moses <moses.mason@HIDDEN>
> > Date: Sun, 15 Jul 2018 00:02:13 +0000
> >
> > For bug#24938, I have to set inhibit-compacting-font-caches to non-nil
> > [0] to fix the lagging issue. It fixes almost but not all the
> > problems. Lagging reappears when I opening a multi languages file
> > (e.g. M-x view-hello-file),  Emacs could become very very slow until
> > the file is completely opened.
>
> That lagging might have a valid reason: how many fonts do you have
> installed?  What does (length (x-list-fonts "*")) return?
>
> If you have many fonts, Emacs will search them all to find a suitable
> one, and if some characters in HELLO don't have fonts, it will search
> them several times.  That might take time.  If the lagging disappears
> once you display the entire file, that is most probably the reason.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 15:40:04 +0000
Resent-Message-ID: <handler.32159.B32159.1531669170742 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.1531669170742
          (code B ref 32159); Sun, 15 Jul 2018 15:40:04 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 15:39:30 +0000
Received: from localhost ([127.0.0.1]:41942 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fej7S-0000Bt-D6
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 11:39:30 -0400
Received: from eggs.gnu.org ([208.118.235.92]:54572)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fej7N-0000BF-7S
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 11:39:25 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1feiDZ-0007gR-E4
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 10:41:48 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:57902)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1feiDZ-0007gG-AF; Sun, 15 Jul 2018 10:41:45 -0400
Received: from [176.228.60.248] (port=3813 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1feiDY-0007VJ-LI; Sun, 15 Jul 2018 10:41:45 -0400
Date: Sun, 15 Jul 2018 17:41:51 +0300
Message-Id: <83in5ga7dc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 (message from Moses on Sun, 15 Jul 2018 05:50:26 +0000)
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Sun, 15 Jul 2018 05:50:26 +0000
> Cc: 32159 <at> debbugs.gnu.org
> 
> You are right. I got 5906 installed fonts returned from (length
> (x-list-fonts "*")). However, this still a problem, which is really
> annoying when editing files that contain more than one language.

Do some of the characters in HELLO display as boxes with hex code
inside them, and if so, do you see slow-down when Emacs is about to
display those characters?  If the answer to both question is YES, I
can suggest a customization to try that might help you avoid the
slowdown (assuming you don't need to be able to display characters
from those scripts), but please tell what characters are involved in
this.

> Other editor does not have the similar issue.

AFAIK, no other editor supports such a large variety of fonts.

> I am not an expert, but as far
> as I know, the font fallback link is already stored in the register
> under key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows
> NT\CurrentVersion\FontLink\SystemLink, why Emacs still needs to search
> fonts multiple times?

I don't think that Registry setting is relevant to the issue at hand.
Emacs looks for fonts based on its internal database of features
required by each script.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Drew Adams <drew.adams@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 16:51:01 +0000
Resent-Message-ID: <handler.32159.B32159.15316734167107 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>, Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15316734167107
          (code B ref 32159); Sun, 15 Jul 2018 16:51:01 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 16:50:16 +0000
Received: from localhost ([127.0.0.1]:41988 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fekDv-0001qX-QJ
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 12:50:16 -0400
Received: from userp2120.oracle.com ([156.151.31.85]:47148)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1fekDt-0001qG-RY
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 12:50:14 -0400
Received: from pps.filterd (userp2120.oracle.com [127.0.0.1])
 by userp2120.oracle.com (8.16.0.22/8.16.0.22) with SMTP id w6FGnBqK144537;
 Sun, 15 Jul 2018 16:50:07 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2018-07-02;
 bh=H3e46y0siv3aB846EtoFzWnQieIov5rnPazWSncdwew=;
 b=kzuur03BtjkGPVPxHaHi07TPBgVIpWulHBGnZ75OqC6CKUkkFHpO3r4leNb1ylluyEJi
 nKADKGyffQTMlEDvhxZdlZB+28iI5aXVf4YbfkEJWiZ1s/wQfJvdqGPj3pHcb8An6B0R
 AM+vOmvREjxun6hRZM04ItAPdSY4ttVJCTVqFgKG4CLIsUQoF4JvxngrPIRtVPYNzs7W
 GDmKcetpdsh5w7d5nyybR6J1xFLVH/emz8Q2DLHaNpUvCfORggvpgyDUotY60aQ/DH3b
 Z2u5jkIGUG26AgCinPTBrtaD0f+wyjEb56Z3erYCPMoSK6qlZYe5FmHqSBC8UW9m6KvP LA== 
Received: from aserv0021.oracle.com (aserv0021.oracle.com [141.146.126.233])
 by userp2120.oracle.com with ESMTP id 2k7a3jj27h-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 15 Jul 2018 16:50:07 +0000
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by aserv0021.oracle.com (8.14.4/8.14.4) with ESMTP id w6FGo6wh022836
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 15 Jul 2018 16:50:06 GMT
Received: from abhmp0011.oracle.com (abhmp0011.oracle.com [141.146.116.17])
 by userv0121.oracle.com (8.14.4/8.13.8) with ESMTP id w6FGo59o018557;
 Sun, 15 Jul 2018 16:50:05 GMT
MIME-Version: 1.0
Message-ID: <0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>
Date: Sun, 15 Jul 2018 09:50:03 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
References: <<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>>
 <<83in5ga7dc.fsf@HIDDEN>>
In-Reply-To: <<83in5ga7dc.fsf@HIDDEN>>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4717.0 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=5900 definitions=8955
 signatures=668706
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=999
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1806210000 definitions=main-1807150203
X-Spam-Score: -2.3 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> > Other editor does not have the similar issue.
>=20
> AFAIK, no other editor supports such a large variety of fonts.

I'll probably get jumped on for chiming in here
ignorantly, but...

It's great to support a large variety of fonts.  But
if a user has lots of fonts installed then it seems
that such an advantage can become a debilitating
(i.e., severe) disadvantage.  This seems like a case
of letting a search for the perfect become the enemy
of the good.

It sounds like Emacs has a do-or-die approach, here,
trying its utmost to find a font that will fit the
bill - and using all installed fonts in its search.

It seems, at least naively, like it should be
possible for a user to control this, by toning down
Emacs's overdrive and enthusiasm in this.

Not that individual users should _have_ to do that
- I don't think they should have to.  But they
should be able to do so - and easily.

Emacs had better analyze what's going on, itself, no?
Doesn't (can't) Emacs have a better understanding of
this problem than a user?  It knows what it's doing,
why, and what the result is - what the problems are.
All a user experiences is a hang/slowdown, and all
they get when they report a bug is the answer that
they likely have too many fonts installed.

If such a font search is taking "too long" (as
determined by some setting perhaps, settable by users
but with a reasonable default value for the average)
then (1) searching should stop and (2) future searches
should be curtailed earlier.

IOW, Emacs should learn when to stop hanging a user
up.  (Having Emacs do that or not should of course
be a user choice - optional.)

Are particular fonts problematic, leading to more
slowdown/hang?  Or is it just the number of fonts
installed that is the problem?  If particular fonts,
then can't Emacs itself learn not to bother with
those fonts (for a given user)?  Why must Emacs
always try _all installed fonts_ each time?

Can't Emacs learn which fonts work for which chars,
so that it doesn't keep trying a given font when
trying to display a given char, after it's already
determined previously that that font doesn't support
that char?

I'm clearly no expert on fonts or Emacs's handling
of them.  So no doubt some of what I'm writing here
makes little sense or betrays misunderstanding.
Please take this only as one naive user's plaint.
This problem is a big one, even if only for the few
(?) users who have many fonts installed.

We (users and Emacs developers) should not be
satisfied by the conclusion that Emacs is incompatible
with having many fonts installed - especially since,
as Moses said, "Other editor does not have the similar
issue."  Even with "too many" fonts installed, Emacs
should be at least as good as other editors.

My question is essentially this: It seems like you
keep saying, and being content to say, that if too
may fonts are installed then Emacs can be slow / hang.

I trust that that's a fact now.  But why should that
be a reason for concluding that nothing can be done?
That's what seems to be happening, at least: the
problem remains, and the prescription seems to be
just "Don't do that.  Don't install so many fonts."
(Or don't use Emacs, I guess.)

To me, that's not a solution.  I have no idea whether
it might be the case that _no_ solution is possible.
But it seems like hands have been thrown up, we've
given up, and "Nothing to be done" is the response.

To those users who do get this "no other editor does
this" behavior - whether you think it's great or
not-so-great that Emacs does it, this is a severe
problem.  With no facts or real understanding of the
underlying code, it seems to this user like Emacs
could/should do better.  The status quo is not good,
for at least some users.

The line is apparently that Emacs does _better_ than
other editors because it tries harder to find a font
that can display a given char.  The fact seems to be
that, at least in some cases (e.g. many fonts
installed), Emacs, in effect, does _worse_ than other
editors.  Hence Moses saying, "Other editor does not
have the similar issue."

A user (I, for example) with many fonts installed
does not suffer dead-in-the-water behavior from
other editors (in the larger sense, i.e., any
text-input, editing, or search context).  I never
see such a problem, outside Emacs.  Never.

Can we not find some way to let users choose the
Emacs full-force-try approach or an approach used
by "other editors"?

Can we not find a way for Emacs itself, by default,
to use better judgment about how far to take its
font-search zeal, so that users do not even have to
make such a choice (but still give them the choice)?

I expect that, even if you agree that that would be
desirable (which I'm not sure you do), you might
say only: "patches welcome".

To which I'd say that this problem seems to have
_started_ at a certain point (relatively) recently,
but it's been with us for a while now, and no new
font expert has stepped forward to tackle it.

I expect that you, Eli, are likely our only hope
anytime soon of addressing this problem.  I hope
you might think more about it, realizing that
"If it hurts, don't do that" is not a reasonable
solution here.

Even if a user were prepared to uninstall a bunch
of fonts - just to make Emacs happy (usable), it's
not clear (to me at least) how s?he would go about
that.

Can Emacs not analyze the problem while it searches
desperately for a font, and so be able to report
about which fonts seem the most useless, least used,
and least useful for Emacs?  That would help a user
think about which fonts s?he might try removing.
Otherwise, how to know?

And beyond putting this burden on the user, can't
such an analysis by Emacs be used by Emacs itself,
to help it try to do the right thing by default -
have it try dropping this or that font from its
search?  IOW, can't Emacs learn about the set of
fonts installed, and not blindly try each one
everytime when trying to display a given char?

Why must the only "solution" be for a user to
uninstall fonts?  Why can't Emacs be prevented
from trying to use some of the installed fonts
for its search?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 18:55:02 +0000
Resent-Message-ID: <handler.32159.B32159.153168084925883 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Drew Adams <drew.adams@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, moses.mason@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153168084925883
          (code B ref 32159); Sun, 15 Jul 2018 18:55:02 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 18:54:09 +0000
Received: from localhost ([127.0.0.1]:42054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fem9o-0006jN-AB
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 14:54:09 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56500)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fem9m-0006ir-0r
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 14:54:06 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1fem9a-0002EB-NO
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 14:54:00 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:60420)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1fem9Y-0002Dx-UE; Sun, 15 Jul 2018 14:53:53 -0400
Received: from [176.228.60.248] (port=3537 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1fem9X-0002d0-Ei; Sun, 15 Jul 2018 14:53:52 -0400
Date: Sun, 15 Jul 2018 21:53:54 +0300
Message-Id: <837elw9vp9.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default> (message from Drew
 Adams on Sun, 15 Jul 2018 09:50:03 -0700 (PDT))
References: <<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>>
 <<83in5ga7dc.fsf@HIDDEN>> <0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> Date: Sun, 15 Jul 2018 09:50:03 -0700 (PDT)
> From: Drew Adams <drew.adams@HIDDEN>
> Cc: 32159 <at> debbugs.gnu.org
> 
> It's great to support a large variety of fonts.  But
> if a user has lots of fonts installed then it seems
> that such an advantage can become a debilitating
> (i.e., severe) disadvantage.

Only if some characters Emacs needs to display are not supported by
any of those many fonts, and if the user didn't customize Emacs to
tell that he/she doesn't _want_ those characters to be displayed,
ever.  How reasonable is such a situation?  Not very reasonable from
my POV.

> This seems like a case of letting a search for the perfect become
> the enemy of the good.

What is "good" in this context, and how do we define it in practical
terms that can allow us to express it in code?

> It sounds like Emacs has a do-or-die approach, here,
> trying its utmost to find a font that will fit the
> bill - and using all installed fonts in its search.

No, it doesn't use all of the installed fonts, only those which
satisfy the requirements of the script whose character Emacs needs to
display.

> It seems, at least naively, like it should be
> possible for a user to control this, by toning down
> Emacs's overdrive and enthusiasm in this.

We have that way: the user should customize the fontset.

> Emacs had better analyze what's going on, itself, no?

And what exactly is "going on", may I ask?

Emacs enumerates the relevant fonts, then goes over them one by one,
determining as quickly as it can whether each font supports the
required features.  Each font that does is opened and looked up for
the character we need to display.  In this context, what do you mean
by "going on"?

> Doesn't (can't) Emacs have a better understanding of
> this problem than a user?

What else can Emacs do except try the fonts that might fit the bill?
What other understanding do you expect from Emacs?  Can Emacs
"understand" that no font is available for a given character without
trying to find such a font?

> IOW, Emacs should learn when to stop hanging a user
> up.

Which is when, exactly?  If you have some ideas, please let us hear
them, even if they are vague.

> Why must Emacs always try _all installed fonts_ each time?

It doesn't, not all of them.  Only those that might be relevant.

> Can't Emacs learn which fonts work for which chars,

It can, and it has.  See the default fontset -- that's the database
Emacs uses to guide the search.

> so that it doesn't keep trying a given font when
> trying to display a given char, after it's already
> determined previously that that font doesn't support
> that char?

Emacs never tries to search for a font that supports a given character
after it has done that once and failed.  But it will look again when
presented with another character, or if we clear the font caches.

> My question is essentially this: It seems like you
> keep saying, and being content to say, that if too
> may fonts are installed then Emacs can be slow / hang.

I'm saying that a system that has 5000 fonts installed and still has
some characters not covered is misconfigured.  Installing one or two
more fonts will probably fix the problem; if the user doesn't _want_
those characters to be displayed, ever, there's a way of customizing
Emacs to do that as well.  Doing none of those alternatives makes no
sense to me, if the slowdown annoys the user who is in this situation.

> I expect that, even if you agree that that would be
> desirable (which I'm not sure you do), you might
> say only: "patches welcome".

Patches to speed up Emacs are always welcome, that's a truism.  Sadly,
I've not seen patches in this particular are in a long, long, long,
LONG time.

> I expect that you, Eli, are likely our only hope
> anytime soon of addressing this problem.

I'm not your hope, I don't know enough about this stuff to redesign it
(assuming that there is a way of redesigning it and getting better
performance for the same level of support for various scripts).  All I
can is try to explain how to configure your system better using the
available features and tricks about which I do know.  That, and
applying some simple band-aid, like inhibit-compacting-font-caches,
from time to time, is all I can do, and am doing.

> Can Emacs not analyze the problem while it searches
> desperately for a font, and so be able to report
> about which fonts seem the most useless, least used,
> and least useful for Emacs?  That would help a user
> think about which fonts s?he might try removing.

From the little I know, there's no answer to that question, even if
you only ask about Emacs.  Of course, people install fonts for other
applications as well, and might not want to uninstall fonts that get
in Emacs's way.

No, the way to solve these problems is to either install a few more
fonts that complete/improve the coverage, and/or customize the
fontsets to make the font search more efficient.

> And beyond putting this burden on the user, can't
> such an analysis by Emacs be used by Emacs itself,
> to help it try to do the right thing by default -
> have it try dropping this or that font from its
> search?  IOW, can't Emacs learn about the set of
> fonts installed, and not blindly try each one
> everytime when trying to display a given char?

We don't have infrastructure for such analysis.  And I don't think we
have anyone on board with expertise to design and code it, even for a
single platform, let alone all of them.  "Patches welcome", of course.

> Why must the only "solution" be for a user to
> uninstall fonts?

See above: it's not the only one.  Not even the best, if you ask me.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Drew Adams <drew.adams@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 15 Jul 2018 19:45:01 +0000
Resent-Message-ID: <handler.32159.B32159.153168384330423 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>, Drew Adams <drew.adams@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, moses.mason@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153168384330423
          (code B ref 32159); Sun, 15 Jul 2018 19:45:01 +0000
Received: (at 32159) by debbugs.gnu.org; 15 Jul 2018 19:44:03 +0000
Received: from localhost ([127.0.0.1]:42071 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1femw6-0007ud-GY
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 15:44:02 -0400
Received: from userp2130.oracle.com ([156.151.31.86]:55480)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1femw4-0007u2-Oi
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 15:44:01 -0400
Received: from pps.filterd (userp2130.oracle.com [127.0.0.1])
 by userp2130.oracle.com (8.16.0.22/8.16.0.22) with SMTP id w6FJhtdE050063;
 Sun, 15 Jul 2018 19:43:55 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2018-07-02;
 bh=fiky0MHoTV5YhuzR9z+DAcU/rTxLnwuy2980eovCffU=;
 b=F7hQ2VJbEolXdYwNhZIZlIA7AcJOPu9y+ZYKeboSCk1pjQ4aGlKemoY7SZ2JvtKGE3VF
 cRuhjRlxOEOTLk3Fm8TdZTM1r8K+kETVQBWB71DycVH48GTU+oUmvBhwzQ2ycYWVUL65
 CBN1xbNkMsFOq0S//gKqEgrU4+lzDwAyUuJsNuBM6cq3iH09YVPkRQC0kjQmt//fRA9m
 h5i0IV28lRa7QOay26DdL6ibzwVDUn31CXZBkA0Dl0at10wb9HtcM52AvCDkYcbMCiwm
 ZOKFsvwvkHxRiZb/iCnglwcWURXiFy8NRhnn+fukVMm9dT9lokP0PwD8wZkgiclFLRiJ Ng== 
Received: from aserv0022.oracle.com (aserv0022.oracle.com [141.146.126.234])
 by userp2130.oracle.com with ESMTP id 2k7a3t26p2-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 15 Jul 2018 19:43:54 +0000
Received: from userv0122.oracle.com (userv0122.oracle.com [156.151.31.75])
 by aserv0022.oracle.com (8.14.4/8.14.4) with ESMTP id w6FJhrnx004055
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 15 Jul 2018 19:43:53 GMT
Received: from abhmp0001.oracle.com (abhmp0001.oracle.com [141.146.116.7])
 by userv0122.oracle.com (8.14.4/8.14.4) with ESMTP id w6FJhpQR027730;
 Sun, 15 Jul 2018 19:43:52 GMT
MIME-Version: 1.0
Message-ID: <45c210aa-5a57-45f7-9bd4-752876b233c2@default>
Date: Sun, 15 Jul 2018 12:43:50 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
References: <<<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>>>
 <<<83in5ga7dc.fsf@HIDDEN>>> <<0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>>
 <<837elw9vp9.fsf@HIDDEN>>
In-Reply-To: <<837elw9vp9.fsf@HIDDEN>>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4717.0 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=5900 definitions=8955
 signatures=668706
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=999
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1806210000 definitions=main-1807150237
X-Spam-Score: -2.3 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Only if some characters Emacs needs to display are not supported by
> any of those many fonts, and if the user didn't customize Emacs to
> tell that he/she doesn't _want_ those characters to be displayed,
> ever.  How reasonable is such a situation?  Not very reasonable from
> my POV.

How is a user to know which characters are problematic, and
thus perhaps to tell Emacs that s?he doesn't want/need those
chars to be displayed?

How is a user to tell Emacs that s?he doesn't want/need this
or that char to be displayed?

> > It seems, at least naively, like it should be
> > possible for a user to control this, by toning down
> > Emacs's overdrive and enthusiasm in this.
>=20
> We have that way: the user should customize the fontset.

How does a user do that?  How does a user know that that
is what needs to be done?  Just what is a user supposed to
do, when s?he determines that Emacs hangs (is slow) because
it tries to search fonts?

> And what exactly is "going on", may I ask?

You tell me.  As a user, the symptom is hanging/slowdown.

> > Doesn't (can't) Emacs have a better understanding of
> > this problem than a user?
>=20
> What else can Emacs do except try the fonts that might fit the bill?
> What other understanding do you expect from Emacs?  Can Emacs
> "understand" that no font is available for a given character without
> trying to find such a font?

Why would Emacs need to do that over and over?  Can't it
record that failure, so it doesn't try again in a future
session?

> > Can't Emacs learn which fonts work for which chars,
>=20
> It can, and it has.  See the default fontset -- that's the database
> Emacs uses to guide the search.

I don't know how to "see" it or what to do when I do see
it.  But a naive guess would be that the default font set
isn't sufficient, if Emacs keeps hanging.

> > so that it doesn't keep trying a given font when
> > trying to display a given char, after it's already
> > determined previously that that font doesn't support
> > that char?
>=20
> Emacs never tries to search for a font that supports a given character
> after it has done that once and failed.

Even across Emacs sessions?  Does it remember that that
happened, so it doesn't try the same font for the same
char in a future session?  If so, great.  In that case,
I don't see why it keeps on hanging (slowdown).

> But it will look again when
> presented with another character, or if we clear the font caches.

Is clearing the font caches something a user does (without
knowing it)?  Am I the one doing that somehow?

Based on what you said in other threads, I've already set
`inhibit-compacting-font-caches' to nil, but that doesn't
seem to have fixed the problem.

> > My question is essentially this: It seems like you
> > keep saying, and being content to say, that if too
> > may fonts are installed then Emacs can be slow / hang.
>=20
> I'm saying that a system that has 5000 fonts installed and still has
> some characters not covered is misconfigured. Installing one or two
> more fonts will probably fix the problem;

So it's about installing more fonts, not uninstalling
fonts because there are too many.  Good to know, I guess.

I'll gladly install one or two more fonts.  I just need
to know what they are and where to get them.  You've often
mentioned Symbola, but I installed that long ago, and it
doesn't seem to have made any difference.

> if the user doesn't _want_ those characters to be displayed, ever,

Dunno what the chars are.  But yes, if some char is
causing Emacs to hang, in spite of the many fonts I
have installed, then at this point I'd say that it
should be ignored: no attempt made to display it.

Is there no way to just tell Emacs that, as a general
rule: don't bother trying to display any chars that
you've previously tried and failed to display?  Above,
you seem to say that Emacs already does that, but it's
not clear whether you meant in the same Emacs session
or persistently.

If it already does that across Emacs sessions then I
don't understand why the problem persists.  It seems
like it would have already learned by now that there
is no sense wasting time trying to (again) look for
a font to display such a char.

> there's a way of customizing Emacs to do that as well.

What way is that?

> Doing none of those alternatives makes no
> sense to me, if the slowdown annoys the user who is in this situation.

Those alternatives are not clear to me.  Perhaps you
could post some instructions somewhere, for what to do
if Emacs hangs because it tries to find a suitable font?

> > I expect that, even if you agree that that would be
> > desirable (which I'm not sure you do), you might
> > say only: "patches welcome".
>=20
> Patches to speed up Emacs are always welcome, that's a truism.  Sadly,
> I've not seen patches in this particular are in a long, long, long,
> LONG time.

Yes, that's too bad.  But I didn't see the problem in
older releases.  At some point (relatively recently, but
I don't recall which release it was - perhaps you do),
the problem began.

> > I expect that you, Eli, are likely our only hope
> > anytime soon of addressing this problem.
>=20
> I'm not your hope, I don't know enough about this stuff to redesign it
> (assuming that there is a way of redesigning it and getting better
> performance for the same level of support for various scripts).  All I
> can is try to explain how to configure your system better using the
> available features and tricks about which I do know.

OK; please do that.  It's not clear to me what a user
should try.

> That, and applying some simple band-aid, like
> inhibit-compacting-font-caches, from time to time, is
> all I can do, and am doing.

OK; thanks for that.  I did set that particular variable
to nil when you first mentioned it.

> > Can Emacs not analyze the problem while it searches
> > desperately for a font, and so be able to report
> > about which fonts seem the most useless, least used,
> > and least useful for Emacs?  That would help a user
> > think about which fonts s?he might try removing.
>=20
> From the little I know, there's no answer to that question, even if
> you only ask about Emacs.  Of course, people install fonts for other
> applications as well, and might not want to uninstall fonts that get
> in Emacs's way.

That's true.  But some users, such as myself, may have
installed fonts that they don't really need and not
know exactly which fonts they might need for this or
that application.

> No, the way to solve these problems is to either install a few more
> fonts that complete/improve the coverage, and/or customize the
> fontsets to make the font search more efficient.

I'd like to know more about each of those possibilities.
I know nothing about the second (customizing fontsets).
Wrt the first, I already installed font Symbola.  I
thought you had indicated that that font should take
care of most chars Emacs itself tends to present to
users (e.g. in `Hello').  But installing Symbola didn't
seem to help.

> > And beyond putting this burden on the user, can't
> > such an analysis by Emacs be used by Emacs itself,
> > to help it try to do the right thing by default -
> > have it try dropping this or that font from its
> > search?  IOW, can't Emacs learn about the set of
> > fonts installed, and not blindly try each one
> > everytime when trying to display a given char?
>=20
> We don't have infrastructure for such analysis.  And I don't think we
> have anyone on board with expertise to design and code it, even for a
> single platform, let alone all of them.  "Patches welcome", of course.

Do you have an idea why Emacs, but not other applications,
seems to have this problem?  You indicated in your answer
earlier that it's because Emacs does much more than others.

If that's the reason, is there a way for a user to dial
back some of that much-more that Emacs does?  Is there a way
for a user to get, in Emacs, the inferior-but-not-hanging
behavior of other applications?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 16 Jul 2018 02:36:01 +0000
Resent-Message-ID: <handler.32159.B32159.15317085519902 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15317085519902
          (code B ref 32159); Mon, 16 Jul 2018 02:36:01 +0000
Received: (at 32159) by debbugs.gnu.org; 16 Jul 2018 02:35:51 +0000
Received: from localhost ([127.0.0.1]:42180 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fetMc-0002Zd-NG
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 22:35:50 -0400
Received: from mail-wr1-f43.google.com ([209.85.221.43]:41275)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1fetMb-0002ZP-FT
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 22:35:49 -0400
Received: by mail-wr1-f43.google.com with SMTP id j5-v6so23755676wrr.8
 for <32159 <at> debbugs.gnu.org>; Sun, 15 Jul 2018 19:35:49 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=bpY3vwAWJ2h5DaAoJaCrFY1ME+eyYTs3yIz1SS+yp40=;
 b=L8POzsRjPQVncn8ZFkRTyLAsLafPp4RMUhN+vVZYjBppa7BzEewBXx/xFyQvxGd91I
 r/ZnkXE7PTdu/wHbQ0MYTsAAPithnlbo2HCQfhroiiz4H/QsZVF+ihhcAC/O2/M5fcHF
 BEutj/FXnWtAuwYeKvRGmgoyAbIyLqXG3r5AsNI27XOAlCXzP0YLJx22jexpaeuxoLe3
 i+kOmsZGpPttGpkNRzQEEUJT0nlgPdbvTziGsp837pcMDtgOJzBC+L6AZ6uUzcglUR6O
 hS2lFH3860uMCHdUkZ17VOMGaPV1ap15RVAWITAhXe7ioWydH1uT/8t6uStQAdegEQMg
 jMwg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=bpY3vwAWJ2h5DaAoJaCrFY1ME+eyYTs3yIz1SS+yp40=;
 b=e+PXn6qsH3ACDpnsAhYBoX+vBT8uZDi38y+aM4ohyELaFEGEEQaqnDqbiOeehAl57P
 340DmvNPmWOeUTSiUntL/dr7jCwZaq9ZGp64uxHQXBb7xS8OujvLJKjS+/OPtPJRxvB1
 vn4YY97Xtfwzh/RoJA2yKNGhUO3JixOmrF6XzWoJLrwGLRs3TN7t91E7N/pXTeFqiOzq
 P4lR04N0inqyVt3w43YpKh60d6k1P2h0N1+mGsdJMa/AjsiC8sPJj0RDfZJI6MWEemaT
 pNl9hQmazScmsVvrcuMRt6SEGtpDGeoxDdZwffjqB99rUiCEsPmFIpLxMBZd6MyAfaFI
 +VQQ==
X-Gm-Message-State: AOUpUlHkDIGIOD5Y+Kik3f3ANrcrDKS/B4DvISxLGOoqVd2hcs7vooOD
 XKN9XSPZNaJrquHgoWmD0jYUezeSgIaPPXULPmY=
X-Google-Smtp-Source: AAOMgpeZiHRRAdYb9Z120V1dhSLwnisjiPYulf7Ddx9KzzVq1rHXFix2QTg470H4LUiPofg8Dw/C1xq699ZN9gS3kX4=
X-Received: by 2002:a5d:4306:: with SMTP id
 h6-v6mr10995004wrq.58.1531708543512; 
 Sun, 15 Jul 2018 19:35:43 -0700 (PDT)
MIME-Version: 1.0
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <83in5ga7dc.fsf@HIDDEN>
In-Reply-To: <83in5ga7dc.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Mon, 16 Jul 2018 10:35:07 +0800
Message-ID: <CAAYZpmSV1CjXUE9BrKW1GZyx3-MpnzEy-BvUfVtB4zC_PT2cjA@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, Jul 15, 2018 at 2:41 PM Eli Zaretskii <eliz@HIDDEN> wrote:
>
> > From: Moses <moses.mason@HIDDEN>
> > Date: Sun, 15 Jul 2018 05:50:26 +0000
> > Cc: 32159 <at> debbugs.gnu.org
> >
> > You are right. I got 5906 installed fonts returned from (length
> > (x-list-fonts "*")). However, this still a problem, which is really
> > annoying when editing files that contain more than one language.
>
> Do some of the characters in HELLO display as boxes with hex code
> inside them, and if so, do you see slow-down when Emacs is about to
> display those characters?  If the answer to both question is YES, I
> can suggest a customization to try that might help you avoid the
> slowdown (assuming you don't need to be able to display characters
> from those scripts), but please tell what characters are involved in
> this.

Nope...all characters in the HELLO file can be display correctly
without a problem, the lagging issue only appears while opening the
file. Once it already opened, there is no more slowdown.

> > Other editor does not have the similar issue.
>
> AFAIK, no other editor supports such a large variety of fonts.

I mean other editors do not have slowdown problem while opening such a
relatively small file. They are not as mighty as Emacs of course.
That's why I am using Emacs to process editing :)


> > I am not an expert, but as far
> > as I know, the font fallback link is already stored in the register
> > under key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows
> > NT\CurrentVersion\FontLink\SystemLink, why Emacs still needs to search
> > fonts multiple times?
>
> I don't think that Registry setting is relevant to the issue at hand.
> Emacs looks for fonts based on its internal database of features
> required by each script.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 16 Jul 2018 03:35:02 +0000
Resent-Message-ID: <handler.32159.B32159.153171207015155 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153171207015155
          (code B ref 32159); Mon, 16 Jul 2018 03:35:02 +0000
Received: (at 32159) by debbugs.gnu.org; 16 Jul 2018 03:34:30 +0000
Received: from localhost ([127.0.0.1]:42202 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1feuHO-0003wM-5n
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:34:30 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50414)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1feuHM-0003w7-Le
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:34:28 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1feuHG-0008Rv-MD
 for 32159 <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:34:23 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:38613)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1feuHB-0008N7-Sd; Sun, 15 Jul 2018 23:34:17 -0400
Received: from [176.12.153.189] (port=54686 helo=[10.161.228.66])
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1feuHB-00041t-A1; Sun, 15 Jul 2018 23:34:17 -0400
Date: Mon, 16 Jul 2018 06:34:13 +0300
User-Agent: K-9 Mail for Android
In-Reply-To: <CAAYZpmSV1CjXUE9BrKW1GZyx3-MpnzEy-BvUfVtB4zC_PT2cjA@HIDDEN>
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <83in5ga7dc.fsf@HIDDEN>
 <CAAYZpmSV1CjXUE9BrKW1GZyx3-MpnzEy-BvUfVtB4zC_PT2cjA@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
From: Eli Zaretskii <eliz@HIDDEN>
Message-ID: <C6DDA6EF-B424-4EC0-AA91-F84BD9E836CF@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

On July 16, 2018 5:35:07 AM GMT+03:00, Moses <moses=2Emason@gmail=2Ecom> wr=
ote:
> On Sun, Jul 15, 2018 at 2:41 PM Eli Zaretskii <eliz@gnu=2Eorg> wrote:
> >
> > > From: Moses <moses=2Emason@gmail=2Ecom>
> > > Date: Sun, 15 Jul 2018 05:50:26 +0000
> > > Cc: 32159@debbugs=2Egnu=2Eorg
> > >
> > > You are right=2E I got 5906 installed fonts returned from (length
> > > (x-list-fonts "*"))=2E However, this still a problem, which is
> really
> > > annoying when editing files that contain more than one language=2E
> >
> > Do some of the characters in HELLO display as boxes with hex code
> > inside them, and if so, do you see slow-down when Emacs is about to
> > display those characters?  If the answer to both question is YES, I
> > can suggest a customization to try that might help you avoid the
> > slowdown (assuming you don't need to be able to display characters
> > from those scripts), but please tell what characters are involved in
> > this=2E
>=20
> Nope=2E=2E=2Eall characters in the HELLO file can be display correctly
> without a problem, the lagging issue only appears while opening the
> file=2E Once it already opened, there is no more slowdown=2E

Okay, then what's your real-life use case?  I doubt you need=20
to display HELLO very often, that was just an example, right?

> > > Other editor does not have the similar issue=2E
> >
> > AFAIK, no other editor supports such a large variety of fonts=2E
>=20
> I mean other editors do not have slowdown problem while opening such a
> relatively small file=2E They are not as mighty as Emacs of course=2E

That's why they don't slow down: their job is easier=2E






Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: net june <netjune@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 16 Jul 2018 03:44:02 +0000
Resent-Message-ID: <handler.32159.B.153171260815976 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 32159 <at> debbugs.gnu.org
X-Debbugs-Original-To: "bug-gnu-emacs@HIDDEN" <bug-gnu-emacs@HIDDEN>
Received: via spool by submit <at> debbugs.gnu.org id=B.153171260815976
          (code B ref -1); Mon, 16 Jul 2018 03:44:02 +0000
Received: (at submit) by debbugs.gnu.org; 16 Jul 2018 03:43:28 +0000
Received: from localhost ([127.0.0.1]:42207 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1feuQ4-00049c-8X
	for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:43:28 -0400
Received: from eggs.gnu.org ([208.118.235.92]:51278)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1feuQ2-00049P-FG
 for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:43:26 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <netjune@HIDDEN>) id 1feuPw-0000nZ-CI
 for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:43:21 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: ***
X-Spam-Status: No, score=3.3 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RECEIVED_FROM_WINDOWS_HOST,T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:49420)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <netjune@HIDDEN>) id 1feuPw-0000mw-95
 for submit <at> debbugs.gnu.org; Sun, 15 Jul 2018 23:43:20 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:42245)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <netjune@HIDDEN>) id 1feuPv-0007qO-3T
 for bug-gnu-emacs@HIDDEN; Sun, 15 Jul 2018 23:43:19 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <netjune@HIDDEN>) id 1feuPr-0000cz-SC
 for bug-gnu-emacs@HIDDEN; Sun, 15 Jul 2018 23:43:19 -0400
Received: from mail-oln040092254075.outbound.protection.outlook.com
 ([40.92.254.75]:54093 helo=APC01-PU1-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <netjune@HIDDEN>) id 1feuPr-0000VL-8u
 for bug-gnu-emacs@HIDDEN; Sun, 15 Jul 2018 23:43:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=uXp/tspq+7hs6G3YlJSPhswlyQtoS9HHv5Pqm3vwUtw=;
 b=OYs3yULrydnvpDs87sMIpMUepZIF1NRbmnOEfS/nZ/oDdmtq1wX2+xB/ObLoy4+8nGA7n34Efs7cfk3irQWBlteG3hSOZr4LzHNRak/IkYFtm2/rF7olCZiw1/yW/x0qOiUQC/29RtnQQTe/EvfAfSF7m+jINn7bnHYrvCONPYjOssqzp5gT70Bgq28k00mkNfBazUKeCocoWpRiBQLP4Y3D7o7y4or4ciBxhV6J82dSgO3xdYIwJBuZ8M7TGn9ueEzegv9ulh8SuKJ3y5rk4LcXqnNxBVV6LfMcVwIFye3AAYyhcNm4GzVZKCFpyOEI7fP/U3CIJKzSrGQhDMHq6w==
Received: from SG2APC01FT044.eop-APC01.prod.protection.outlook.com
 (10.152.250.57) by SG2APC01HT021.eop-APC01.prod.protection.outlook.com
 (10.152.251.95) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384_P384) id 15.20.952.17; Mon, 16
 Jul 2018 03:43:11 +0000
Received: from PS1PR04MB2821.apcprd04.prod.outlook.com (10.152.250.56) by
 SG2APC01FT044.mail.protection.outlook.com (10.152.250.239) with Microsoft
 SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256_P256) id 15.20.952.17 via
 Frontend Transport; Mon, 16 Jul 2018 03:43:11 +0000
Received: from PS1PR04MB2821.apcprd04.prod.outlook.com
 ([fe80::9c63:c9d1:4af1:5d7f]) by PS1PR04MB2821.apcprd04.prod.outlook.com
 ([fe80::9c63:c9d1:4af1:5d7f%3]) with mapi id 15.20.0952.021; Mon, 16 Jul 2018
 03:43:10 +0000
From: net june <netjune@HIDDEN>
Thread-Topic: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all
 fonts lagging issue
Thread-Index: AQHUHLcdncq0lZtR50OV0SdFO2sCxw==
Date: Mon, 16 Jul 2018 03:43:10 +0000
Message-ID: <PS1PR04MB28210F5306C09BBD796C5C9FB75D0@HIDDEN>
References: <<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <<83in5ga7dc.fsf@HIDDEN> <0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>
 <837elw9vp9.fsf@HIDDEN>
In-Reply-To: <837elw9vp9.fsf@HIDDEN>
Accept-Language: zh-CN, en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
x-clientproxiedby: HK2P15301CA0016.APCP153.PROD.OUTLOOK.COM (10.170.144.154)
 To PS1PR04MB2821.apcprd04.prod.outlook.com (20.177.133.138)
x-incomingtopheadermarker: OriginalChecksum:7117973C29E49016B4E1067ECBFE86F59A60791FA4F77435DE6A4DE2ECDB0AFE;
 UpperCasedChecksum:8C44A66282A7D0BEB7EBE98F95650B87FE517383C82AC24A4B52A89197DB184C;
 SizeAsReceived:7616; Count:49
x-ms-exchange-messagesentrepresentingtype: 1
x-tmn: [+cLk3pRHaXebpbXj1k7uyKZjfsiHNnGN]
x-ms-publictraffictype: Email
x-microsoft-exchange-diagnostics: 1; SG2APC01HT021;
 7:VklYi1kBWv4VUwO1KuMFbZCwG+K/wQ605ez3wWKPxaXYm5Zc7uLkcliarNfSAT8efX2RXl4rAm62IhginhijKJ33KJya3OjEyRktojdBS999GDbhe2PC1YddKr812aizsG21ztaGM22ShEjRFbnJbXvzBCs/8EThFzUAPWN6uoorARJ2/Hi6dsGOnkwepZ8ZO9trjD5lVDpDY0DUgAJKZb5sIQR7/zrzN78SXixhqHG10LiAGuUXQPT2laLHTv8F
x-incomingheadercount: 49
x-eopattributedmessage: 0
x-microsoft-antispam: UriScan:; BCL:0; PCL:0;
 RULEID:(7020095)(201702061078)(5061506573)(5061507331)(1603103135)(2017031320274)(2017031324274)(2017031323274)(2017031322404)(1603101448)(1601125500)(1701031045);
 SRVR:SG2APC01HT021; 
x-ms-traffictypediagnostic: SG2APC01HT021:
x-exchange-antispam-report-cfa-test: BCL:0; PCL:0; RULEID:(82015058);
 SRVR:SG2APC01HT021; BCL:0; PCL:0; RULEID:; SRVR:SG2APC01HT021; 
x-forefront-prvs: 073515755F
x-forefront-antispam-report: SFV:NSPM;
 SFS:(7070007)(199004)(189003)(486006)(476003)(81156014)(8676002)(33656002)(99286004)(229853002)(20460500001)(97736004)(6436002)(86152003)(55016002)(8936002)(102836004)(7696005)(386003)(76176011)(6346003)(93886005)(5640700003)(74316002)(53546011)(26005)(106356001)(68736007)(2351001)(105586002)(82202002)(446003)(11346002)(305945005)(86362001)(104016004)(2900100001)(5660300001)(256004)(6916009)(6246003)(14454004)(2501003)(56003)(5250100002)(25786009)(87572001)(426003);
 DIR:OUT; SFP:1901; SCL:1; SRVR:SG2APC01HT021;
 H:PS1PR04MB2821.apcprd04.prod.outlook.com; FPR:; SPF:None; PTR:InfoNoRecords;
 A:1; MX:1; LANG:; 
received-spf: None (protection.outlook.com: outlook.com does not designate
 permitted sender hosts)
authentication-results: spf=none (sender IP is )
 smtp.mailfrom=netjune@HIDDEN; 
x-microsoft-antispam-message-info: VJqmjlXE4usFtu4cTPHbRZGPaGZc/v/W5jFAuYiR/1UTaOwmlGGN/jcCp8ss2UKat0slkTfPtNm6KVDEZq8VQeavLplPlfuVbEHU/fLIHyIpli3i9JSRcTbAUVMTo2NDExpRq8o/k6z2ecyXHT3/fQeH/gWeHiUJQmEQKFBLYRPBHaQ+HoUvAfx6N3k1I47+6JS2kwrIItAl6PZBMRp/q26L6TVlKn6BSQVOCw1rlWU=
Content-Type: text/plain; charset="utf-8"
Content-ID: <09DD49E491B8B745A935A2C0935E5374@HIDDEN>
Content-Transfer-Encoding: base64
MIME-Version: 1.0
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 24fd1209-d934-423e-a578-ee886993c07f
X-MS-Exchange-CrossTenant-Network-Message-Id: b88831a6-bf75-4cdf-7562-08d5eace4049
X-MS-Exchange-CrossTenant-rms-persistedconsumerorg: 24fd1209-d934-423e-a578-ee886993c07f
X-MS-Exchange-CrossTenant-originalarrivaltime: 16 Jul 2018 03:43:10.8403 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Internet
X-MS-Exchange-CrossTenant-id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-Transport-CrossTenantHeadersStamped: SG2APC01HT021
X-detected-operating-system: by eggs.gnu.org: Windows 7 or 8 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

DQoNCk9uIDA3LzE2LzIwMTggMDI6NTMgQU0sIEVsaSBaYXJldHNraWkgd3JvdGU6DQo+PiBEYXRl
OiBTdW4sIDE1IEp1bCAyMDE4IDA5OjUwOjAzIC0wNzAwIChQRFQpDQo+PiBGcm9tOiBEcmV3IEFk
YW1zIDxkcmV3LmFkYW1zQG9yYWNsZS5jb20+DQo+PiBDYzogMzIxNTlAZGViYnVncy5nbnUub3Jn
DQo+Pg0KPj4gSXQncyBncmVhdCB0byBzdXBwb3J0IGEgbGFyZ2UgdmFyaWV0eSBvZiBmb250cy4g
IEJ1dA0KPj4gaWYgYSB1c2VyIGhhcyBsb3RzIG9mIGZvbnRzIGluc3RhbGxlZCB0aGVuIGl0IHNl
ZW1zDQo+PiB0aGF0IHN1Y2ggYW4gYWR2YW50YWdlIGNhbiBiZWNvbWUgYSBkZWJpbGl0YXRpbmcN
Cj4+IChpLmUuLCBzZXZlcmUpIGRpc2FkdmFudGFnZS4NCj4gDQo+IE9ubHkgaWYgc29tZSBjaGFy
YWN0ZXJzIEVtYWNzIG5lZWRzIHRvIGRpc3BsYXkgYXJlIG5vdCBzdXBwb3J0ZWQgYnkNCj4gYW55
IG9mIHRob3NlIG1hbnkgZm9udHMsIGFuZCBpZiB0aGUgdXNlciBkaWRuJ3QgY3VzdG9taXplIEVt
YWNzIHRvDQo+IHRlbGwgdGhhdCBoZS9zaGUgZG9lc24ndCBfd2FudF8gdGhvc2UgY2hhcmFjdGVy
cyB0byBiZSBkaXNwbGF5ZWQsDQo+IGV2ZXIuICBIb3cgcmVhc29uYWJsZSBpcyBzdWNoIGEgc2l0
dWF0aW9uPyAgTm90IHZlcnkgcmVhc29uYWJsZSBmcm9tDQo+IG15IFBPVi4NCj4gDQoNCklzIGl0
IHBvc3NpYmxlIHRvIHNhdmUgdGhlIGZvbnQgc2VhcmNoIHJlc3VsdCB0byBmaWxlIChjdXN0b20g
ZmlsZSkgZm9yIA0KbmV4dCB1c2U/IFRoZW4gd2UganVzdCBuZWVkIHRvIG9wZW4gdGhlIEhFTExP
IGZpbGUgb25jZSB0byBjYWNoZSB0aGUgcmVzdWx0Lg0KDQo=




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 16 Jul 2018 14:23:01 +0000
Resent-Message-ID: <handler.32159.B32159.153175097827298 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Drew Adams <drew.adams@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, moses.mason@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153175097827298
          (code B ref 32159); Mon, 16 Jul 2018 14:23:01 +0000
Received: (at 32159) by debbugs.gnu.org; 16 Jul 2018 14:22:58 +0000
Received: from localhost ([127.0.0.1]:43885 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ff4Ov-00076D-FV
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:22:57 -0400
Received: from eggs.gnu.org ([208.118.235.92]:49607)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ff4Ot-00075x-N3
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:22:56 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ff4Ok-00073S-3Y
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:22:50 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:46644)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ff4Oj-00073M-Ut; Mon, 16 Jul 2018 10:22:46 -0400
Received: from [176.228.60.248] (port=3578 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ff4Oj-0000Ik-BP; Mon, 16 Jul 2018 10:22:45 -0400
Date: Mon, 16 Jul 2018 17:22:54 +0300
Message-Id: <8336wj9s5d.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <45c210aa-5a57-45f7-9bd4-752876b233c2@default> (message from Drew
 Adams on Sun, 15 Jul 2018 12:43:50 -0700 (PDT))
References: <<<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>>>
 <<<83in5ga7dc.fsf@HIDDEN>>> <<0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>>
 <<837elw9vp9.fsf@HIDDEN>> <45c210aa-5a57-45f7-9bd4-752876b233c2@default>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> Date: Sun, 15 Jul 2018 12:43:50 -0700 (PDT)
> From: Drew Adams <drew.adams@HIDDEN>
> Cc: moses.mason@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> How is a user to know which characters are problematic, and
> thus perhaps to tell Emacs that s?he doesn't want/need those
> chars to be displayed?

In most cases, those characters are displayed as boxes with hex code
inside, to mean no font was found for them.  If that's not the case,
only trial and error (display text with and without portions of the
buffer) will uncover them.

> How is a user to tell Emacs that s?he doesn't want/need this
> or that char to be displayed?

"C-u C-x =" displays the answer to that question, and much more.

Whether the user does or doesn't want a given character displayed is
up to the user: only users know which scripts they want to be legible
in their usage of Emacs.

> > We have that way: the user should customize the fontset.

> How does a user do that?

See the 2 manuals, where they document 'set-fontset-font'.  There's a
lot of info there, with examples.

> How does a user know that that is what needs to be done?

They are supposed to read the manuals, and this and similar
discussions.

> Just what is a user supposed to do, when s?he determines that Emacs
> hangs (is slow) because it tries to search fonts?

See above.

> > And what exactly is "going on", may I ask?
> 
> You tell me.  As a user, the symptom is hanging/slowdown.

That's Emacs searching for a suitable font.  Nothing else is going on.

> > > Doesn't (can't) Emacs have a better understanding of
> > > this problem than a user?
> > 
> > What else can Emacs do except try the fonts that might fit the bill?
> > What other understanding do you expect from Emacs?  Can Emacs
> > "understand" that no font is available for a given character without
> > trying to find such a font?
> 
> Why would Emacs need to do that over and over?  Can't it
> record that failure, so it doesn't try again in a future
> session?

It does record the failure, but only for this session.  Recording that
for future session (a.k.a. "caching") has its own problems: the cache
needs to be refreshed when fonts are installed or uninstalled, so it's
a mixed blessing.  The best way to "cache" the information is to
customize the fontset to record user preferences, as discussed here.

> > > Can't Emacs learn which fonts work for which chars,
> > 
> > It can, and it has.  See the default fontset -- that's the database
> > Emacs uses to guide the search.
> 
> I don't know how to "see" it

(Did you try 'apropos'?) "M-x describe-fontset RET RET" will show
that.  Be prepared for it to take a couple of dozen of seconds: it
goes through the entire range of Unicode characters.

> or what to do when I do see it.

See above and below.

> But a naive guess would be that the default font set isn't
> sufficient, if Emacs keeps hanging.

It's a starting point for further customization and optimization.

It is practically impossible to make Emacs OOTB fit every system out
there, because the fonts installed on each systems cannot be known in
advance.  Plus, some popular fonts are not free, and we don't want to
advertise/support them by including them in the default fontset.  The
defaults are supposed to cover the "usual" setups, and indeed IME
complaints about this are mostly for rare and exotic use cases.  Of
course, this particular case might just be one that will trigger some
changes in Emacs, I don't know yet.

> > > so that it doesn't keep trying a given font when
> > > trying to display a given char, after it's already
> > > determined previously that that font doesn't support
> > > that char?
> > 
> > Emacs never tries to search for a font that supports a given character
> > after it has done that once and failed.
> 
> Even across Emacs sessions?

No, only during the same session.

> > But it will look again when
> > presented with another character, or if we clear the font caches.
> 
> Is clearing the font caches something a user does (without
> knowing it)?

It's part of GC.  inhibit-compacting-font-caches disables it.

> Based on what you said in other threads, I've already set
> `inhibit-compacting-font-caches' to nil, but that doesn't
> seem to have fixed the problem.

It fixes a different problem.  It doesn't affect the search for a
suitable font when a given character needs to be displayed for the
first time.

> > I'm saying that a system that has 5000 fonts installed and still has
> > some characters not covered is misconfigured. Installing one or two
> > more fonts will probably fix the problem;
> 
> So it's about installing more fonts, not uninstalling
> fonts because there are too many.  Good to know, I guess.

It's a better solution, if you need to display the characters which
appear as boxes and/or those for which Emacs takes a long time to
search for a font.  An even better solution is to (also) customize
your fontset to specify fonts for specific scripts or character code
ranges, according to the fonts you have and/or whose appearance you
like.  That could bypass the search entirely in some cases.

> I'll gladly install one or two more fonts.  I just need
> to know what they are and where to get them.

Find the characters that display as boxes, then look for fonts that
support those characters, and install one of those fonts.

> > if the user doesn't _want_ those characters to be displayed, ever,
> 
> Dunno what the chars are.

See above.

> Is there no way to just tell Emacs that, as a general
> rule: don't bother trying to display any chars that
> you've previously tried and failed to display?

It already does that, in the same session.  See above about caching.

> > there's a way of customizing Emacs to do that as well.
> 
> What way is that?

See above and below.

> > Doing none of those alternatives makes no
> > sense to me, if the slowdown annoys the user who is in this situation.
> 
> Those alternatives are not clear to me.  Perhaps you
> could post some instructions somewhere, for what to do
> if Emacs hangs because it tries to find a suitable font?

Fontset customization is not just for "hanging", it's for any
situation where Emacs chooses a font that you don't like for some
reason, and you want it to choose another one.  It also helps to speed
up the search for fonts.  For example, the following setup speeds up
the initial display of HELLO by a factor of 5, from about 20 sec to
just 4:

  (set-fontset-font "fontset-default" 'gujarati '("Shruti" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'devanagari '("Mangal" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'kannada '("Tunga" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'malayalam '("Kartika" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'oriya '("Kalinga" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'sinhala '("Iskoola Pota" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'tamil '("Latha" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'telugu '("Gautami" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'tibetan '("Microsoft Himalaya" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'burmese nil)

The fonts mentioned above are those available OOTB on a Windows
machine I have here; yours may be different.  I collected them using
"C-u C-x =" for characters whose presence makes display of HELLO
significantly slower.  If you don't have a font available for some
script and/or don't want that script's characters displayed, you can
replace the last argument of 'set-fontset-font' with nil, like I did
for 'burmese'.  (You can also use ranges of codepoints instead of
script symbols; see the doc string of 'set-fontset-font'.)

The script of a character is also shown by "C-u C-x =".

> Yes, that's too bad.  But I didn't see the problem in
> older releases.  At some point (relatively recently, but
> I don't recall which release it was - perhaps you do),
> the problem began.

The only change was the one that is disabled by
'inhibit-compacting-font-caches'.  Other than that, it's probably the
fonts you installed.  If not, I don't know what could be the reason.

> > > Can Emacs not analyze the problem while it searches
> > > desperately for a font, and so be able to report
> > > about which fonts seem the most useless, least used,
> > > and least useful for Emacs?  That would help a user
> > > think about which fonts s?he might try removing.
> > 
> > From the little I know, there's no answer to that question, even if
> > you only ask about Emacs.  Of course, people install fonts for other
> > applications as well, and might not want to uninstall fonts that get
> > in Emacs's way.
>
> That's true.  But some users, such as myself, may have
> installed fonts that they don't really need and not
> know exactly which fonts they might need for this or
> that application.

I don't know how to solve this.  You will have to analyze your
font-related needs in some systematic way.  I find the BabelMap
program useful for studying the installed fonts, btw.

> > No, the way to solve these problems is to either install a few more
> > fonts that complete/improve the coverage, and/or customize the
> > fontsets to make the font search more efficient.
> 
> I'd like to know more about each of those possibilities.
> I know nothing about the second (customizing fontsets).

See above.

> Wrt the first, I already installed font Symbola.  I
> thought you had indicated that that font should take
> care of most chars Emacs itself tends to present to
> users (e.g. in `Hello').  But installing Symbola didn't
> seem to help.

Symbola may not help for HELLO, but that's not an interesting use
case, usually.  Symbola does help in many real-life use cases, I see
that every day on my systems.

> Do you have an idea why Emacs, but not other applications,
> seems to have this problem?  You indicated in your answer
> earlier that it's because Emacs does much more than others.

Yes.  Emacs optimizes the fonts it chooses for the scripts of the
characters it needs to display.

> If that's the reason, is there a way for a user to dial
> back some of that much-more that Emacs does?

Yes, by customizing the fontset; see above,




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 16 Jul 2018 14:25:02 +0000
Resent-Message-ID: <handler.32159.B32159.153175105327445 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: net june <netjune@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153175105327445
          (code B ref 32159); Mon, 16 Jul 2018 14:25:02 +0000
Received: (at 32159) by debbugs.gnu.org; 16 Jul 2018 14:24:13 +0000
Received: from localhost ([127.0.0.1]:43889 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ff4Q9-00078a-3L
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:24:13 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50261)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ff4Q8-00078O-7C
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:24:12 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ff4Py-0007lr-3X
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 10:24:06 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:46666)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ff4Px-0007lk-VY; Mon, 16 Jul 2018 10:24:02 -0400
Received: from [176.228.60.248] (port=3655 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ff4Px-0000OE-Er; Mon, 16 Jul 2018 10:24:01 -0400
Date: Mon, 16 Jul 2018 17:24:10 +0300
Message-Id: <831sc39s39.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <PS1PR04MB28210F5306C09BBD796C5C9FB75D0@HIDDEN>
 (message from net june on Mon, 16 Jul 2018 03:43:10 +0000)
References: <<CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <<83in5ga7dc.fsf@HIDDEN>
 <0c4b0a47-267d-4c4d-8d1f-6a562ac7519b@default>
 <837elw9vp9.fsf@HIDDEN>
 <PS1PR04MB28210F5306C09BBD796C5C9FB75D0@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: net june <netjune@HIDDEN>
> Date: Mon, 16 Jul 2018 03:43:10 +0000
> 
> Is it possible to save the font search result to file (custom file) for 
> next use? Then we just need to open the HELLO file once to cache the result.

I tried to explain in my other mail the downsides of caching font
information.  If you use Emacs as intended, i.e. by having a single
session running at all times, the cache is inside Emacs anyway.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 01:40:02 +0000
Resent-Message-ID: <handler.32159.B32159.15317915439164 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15317915439164
          (code B ref 32159); Tue, 17 Jul 2018 01:40:02 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 01:39:03 +0000
Received: from localhost ([127.0.0.1]:44274 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffExD-0002Nk-FT
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 21:39:03 -0400
Received: from mail-wr1-f45.google.com ([209.85.221.45]:41384)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1ffExB-0002NE-Lo
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 21:39:02 -0400
Received: by mail-wr1-f45.google.com with SMTP id j5-v6so27163656wrr.8
 for <32159 <at> debbugs.gnu.org>; Mon, 16 Jul 2018 18:39:01 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=Uu+URZ+Wlb3Wo/+FtfVLWyOUoC2Tl4oM5mvcG9caEjA=;
 b=IiGOMCJe6AdP9EgNhnTbG+n2G5PkAEGDc9maC9MR+Gsmz+a2G/C+5UkoxC7IhEHnHK
 1OkKH1ZwGUDbWqAATE2ejatbLRII0khES8iQH2VWRdNYk9aLM2JSXmqC+JTyIUIsdrM6
 phkUtSSYkzJMkVhwqgbvJQuTH6SnNZyuE7MLM9DmA2OxnaBdGX7xgirk4BPInLnN8uCh
 TWmZb284xH4J9+RIneoegAXIYr7W1BORWIGf8UKZiv3HdB0GNxP5q0r5DlbIh/AcqksI
 RTGv2VD1cVniG7xrR/E5XPGaJZ+NJCpaRgh7sma+3+3LzxlOtazni7EVANTXwQr+tWFt
 WIOQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=Uu+URZ+Wlb3Wo/+FtfVLWyOUoC2Tl4oM5mvcG9caEjA=;
 b=lSeBoonuIXH9D1BzwYgLXDiY8Q5uZnndt9P6ou8H9uaCcFDxidgdiPFK/jVbJyRhZq
 8GrQQTKySzFbylE1zwSshAO3iHEIG63Ecs4b07TFRhGOXbg7UmxlDYKQN6GCOYH3W05K
 qOGVw9f5r2WqYfOF36vIzKE6CkNkfm6QtuWLp+ZE8q6W/OWYqN/l26Xx89CGCrfDN578
 /9eMyGtVPUO3zZGjsEmockfezcSAFf6pAe8c3nWZxU8myfl2fO8sIp/YW39HKPYx1v1N
 M82MULUWEYDi8WrsnbJ4ZQ8pwc/v1yU7QpRQcE7qeMD/lrQLPwDbh6kuXI/Xo0qlDjBi
 QhAg==
X-Gm-Message-State: AOUpUlHm3Pj1e7H8c6UgjXiabAeTO8/l+hlcCUtfKov5iA3Gf5Xjuq/s
 yNpIqu40xXViPjj6jzOvLd98xCB6LWSY58Wubvk=
X-Google-Smtp-Source: AAOMgpdXgR4nz4bpNw3tYZrAdalJs/jJMKJ1kKLoHPntMKQNhFHSaHHtjggh0FibzRsZ/dLW5BPdglh+lcL++U/tsyQ=
X-Received: by 2002:adf:ed41:: with SMTP id
 u1-v6mr13032032wro.262.1531791535838; 
 Mon, 16 Jul 2018 18:38:55 -0700 (PDT)
MIME-Version: 1.0
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <83in5ga7dc.fsf@HIDDEN>
 <CAAYZpmSV1CjXUE9BrKW1GZyx3-MpnzEy-BvUfVtB4zC_PT2cjA@HIDDEN>
 <C6DDA6EF-B424-4EC0-AA91-F84BD9E836CF@HIDDEN>
In-Reply-To: <C6DDA6EF-B424-4EC0-AA91-F84BD9E836CF@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Tue, 17 Jul 2018 09:38:20 +0800
Message-ID: <CAAYZpmRnujb45uA8F+aOQQA06gytXSxnCMKJEFAfAXvwrH=ooA@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, Jul 16, 2018 at 11:34 AM Eli Zaretskii <eliz@HIDDEN> wrote:
> > Nope...all characters in the HELLO file can be display correctly
> > without a problem, the lagging issue only appears while opening the
> > file. Once it already opened, there is no more slowdown.
>
> Okay, then what's your real-life use case?  I doubt you need
> to display HELLO very often, that was just an example, right?

Well, in my real-life case it is a little complicated. I often editing
files other than English, besides that, I use Emacs doing a lot of
things, such as Gnus to read news and Twitter-mode to read tweets.
Please assume all these jobs involve multiple languages. So if one
content makes Emacs slow down, then it seriously affects my daily
Emacs usage.

> That's why they don't slow down: their job is easier.

At least some optimize can be done, isn't it?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 02:14:01 +0000
Resent-Message-ID: <handler.32159.B32159.153179362819812 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153179362819812
          (code B ref 32159); Tue, 17 Jul 2018 02:14:01 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 02:13:48 +0000
Received: from localhost ([127.0.0.1]:44291 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffFUp-00059U-Tj
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:13:48 -0400
Received: from mail-wm0-f52.google.com ([74.125.82.52]:38808)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1ffFUo-00059H-DL
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:13:46 -0400
Received: by mail-wm0-f52.google.com with SMTP id 69-v6so17572227wmf.3
 for <32159 <at> debbugs.gnu.org>; Mon, 16 Jul 2018 19:13:46 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=vrJEmII/39ZnHoZQBQFlqGZpa506RtbQEGxkn0+nHTQ=;
 b=Jqu5OqeLL4Pg6CYCPdCw33/6mS7LVNxqiAWMhl81LzFJowG9r9CwJwjiAdwwzoxO9t
 Z3Vc94lGcKOvUtRJcwWQi7rr8sm2f8RwNnTjkZfeNCZSBbd1G+B3jjJ5X0g1W0btp7X2
 8nnYgt8rqeMk4+Sw7DuFovPRMXh9wucUI0ibEjANcXWJdw28IyA+Mh2ItObCJgbkPLEN
 CjhDw5C3EGu5I2mts6VRG3xDmRqtro635oV5AUxYDrpahKbrIYKEAmzUnf0wiCUZVkS/
 mME0ZcWnKqqpEPsLFr27qVkhycXeL1iDwjaKgYhNTfEhXQSfcaeIQp80Zh2AFI7b6BFS
 XOMA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=vrJEmII/39ZnHoZQBQFlqGZpa506RtbQEGxkn0+nHTQ=;
 b=Cad1WHuHt1EpDcJW/33tl3fE/NJFY3OVYjxsqQl9yPTZERDE2J5yybUHellKXvmt+b
 tMYcYx91hKzRjHtKfU9fKenT94R+E3cKB4ospbMFhjYgWzzXeQJZe1RNDATOKyHlK8mj
 1LdFfxumZcD+nkQm3hyKAttxWM5W3zodaHYJgzsYv02pNtwzUl5h7cLx9sh3731jKuCr
 U+uI7C8kAY9OSngO46KIqDdyp0gsTRAkAomKuddKsO+nqj6t1V5SgA+p94LBYieUpkyX
 8H3A9OYNFjyyxEVvI1N1UjLZVLjKAVZeo//dAi+rsbalPT1DYG7QAF8ehTU8sjfhyDQw
 3hKw==
X-Gm-Message-State: AOUpUlGTrtmgXi86B9qXeseyXJVbN1YlpEKF8Y3hv4bZkWPcjWwrSBP7
 Qiiyxn5foIdniCtru3vBRdLkIBL2CfU09vnPQZQ=
X-Google-Smtp-Source: AAOMgpdN/4iUr8hEAr/RIWvCKAq0vUYiBNizNE2G2vqVPbGACqzd8bNuuN9kNA85T+z80nR6W4Fo+Fr98Ad+E3j/hvQ=
X-Received: by 2002:a1c:570a:: with SMTP id l10-v6mr33000wmb.56.1531793620623; 
 Mon, 16 Jul 2018 19:13:40 -0700 (PDT)
MIME-Version: 1.0
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
In-Reply-To: <8336wj9s5d.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Tue, 17 Jul 2018 10:13:05 +0800
Message-ID: <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, Jul 16, 2018 at 10:22 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> Fontset customization is not just for "hanging", it's for any
> situation where Emacs chooses a font that you don't like for some
> reason, and you want it to choose another one.  It also helps to speed
> up the search for fonts.  For example, the following setup speeds up
> the initial display of HELLO by a factor of 5, from about 20 sec to
> just 4:
>
>   (set-fontset-font "fontset-default" 'gujarati '("Shruti" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'devanagari '("Mangal" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'kannada '("Tunga" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'malayalam '("Kartika" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'oriya '("Kalinga" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'sinhala '("Iskoola Pota" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'tamil '("Latha" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'telugu '("Gautami" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'tibetan '("Microsoft Himalaya" . "iso10646-1"))
>   (set-fontset-font "fontset-default" 'burmese nil)
>
> The fonts mentioned above are those available OOTB on a Windows
> machine I have here; yours may be different.  I collected them using
> "C-u C-x =" for characters whose presence makes display of HELLO
> significantly slower.  If you don't have a font available for some
> script and/or don't want that script's characters displayed, you can
> replace the last argument of 'set-fontset-font' with nil, like I did
> for 'burmese'.  (You can also use ranges of codepoints instead of
> script symbols; see the doc string of 'set-fontset-font'.)
>
> The script of a character is also shown by "C-u C-x =".

How to get the correct second argument (script name?) and also the
"iso10646-1" (encoding name?)? I do not find it in C-u C-x = and the
manual is not very clear about that. Anyway, why Emacs can not
generate a "suggestion" of set-fontset-font in the first place and
tell user to add it into .emacs? That would be very helpful.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 02:39:02 +0000
Resent-Message-ID: <handler.32159.B32159.153179510922249 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153179510922249
          (code B ref 32159); Tue, 17 Jul 2018 02:39:02 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 02:38:29 +0000
Received: from localhost ([127.0.0.1]:44304 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffFsj-0005mn-AY
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:38:29 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56342)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ffFsh-0005mc-Vy
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:38:28 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ffFsX-0003z8-O7
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:38:22 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:59025)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ffFsX-0003z4-JM; Mon, 16 Jul 2018 22:38:17 -0400
Received: from [176.228.60.248] (port=1045 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ffFsX-0005W2-0C; Mon, 16 Jul 2018 22:38:17 -0400
Date: Tue, 17 Jul 2018 05:38:26 +0300
Message-Id: <83zhyq7fj1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmRnujb45uA8F+aOQQA06gytXSxnCMKJEFAfAXvwrH=ooA@HIDDEN>
 (message from Moses on Tue, 17 Jul 2018 09:38:20 +0800)
References: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
 <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <83in5ga7dc.fsf@HIDDEN>
 <CAAYZpmSV1CjXUE9BrKW1GZyx3-MpnzEy-BvUfVtB4zC_PT2cjA@HIDDEN>
 <C6DDA6EF-B424-4EC0-AA91-F84BD9E836CF@HIDDEN>
 <CAAYZpmRnujb45uA8F+aOQQA06gytXSxnCMKJEFAfAXvwrH=ooA@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Tue, 17 Jul 2018 09:38:20 +0800
> Cc: 32159 <at> debbugs.gnu.org
> 
> On Mon, Jul 16, 2018 at 11:34 AM Eli Zaretskii <eliz@HIDDEN> wrote:
> > > Nope...all characters in the HELLO file can be display correctly
> > > without a problem, the lagging issue only appears while opening the
> > > file. Once it already opened, there is no more slowdown.
> >
> > Okay, then what's your real-life use case?  I doubt you need
> > to display HELLO very often, that was just an example, right?
> 
> Well, in my real-life case it is a little complicated. I often editing
> files other than English, besides that, I use Emacs doing a lot of
> things, such as Gnus to read news and Twitter-mode to read tweets.
> Please assume all these jobs involve multiple languages. So if one
> content makes Emacs slow down, then it seriously affects my daily
> Emacs usage.

I can only suggest customizing your fontset in the way I show in my
previous message.

> > That's why they don't slow down: their job is easier.
> 
> At least some optimize can be done, isn't it?

What optimizations did you have in mind?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 02:41:01 +0000
Resent-Message-ID: <handler.32159.B32159.153179524622473 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153179524622473
          (code B ref 32159); Tue, 17 Jul 2018 02:41:01 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 02:40:46 +0000
Received: from localhost ([127.0.0.1]:44308 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffFuv-0005qO-OO
	for submit <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:40:45 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56756)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ffFut-0005qB-UX
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:40:44 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ffFun-0004si-TZ
 for 32159 <at> debbugs.gnu.org; Mon, 16 Jul 2018 22:40:38 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:59043)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ffFun-0004sb-PS; Mon, 16 Jul 2018 22:40:37 -0400
Received: from [176.228.60.248] (port=1195 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ffFun-0005ek-7H; Mon, 16 Jul 2018 22:40:37 -0400
Date: Tue, 17 Jul 2018 05:40:47 +0300
Message-Id: <83y3ea7ff4.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 (message from Moses on Tue, 17 Jul 2018 10:13:05 +0800)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Tue, 17 Jul 2018 10:13:05 +0800
> Cc: drew.adams@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> >   (set-fontset-font "fontset-default" 'gujarati '("Shruti" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'devanagari '("Mangal" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'kannada '("Tunga" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'malayalam '("Kartika" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'oriya '("Kalinga" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'sinhala '("Iskoola Pota" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'tamil '("Latha" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'telugu '("Gautami" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'tibetan '("Microsoft Himalaya" . "iso10646-1"))
> >   (set-fontset-font "fontset-default" 'burmese nil)
> >
> > The fonts mentioned above are those available OOTB on a Windows
> > machine I have here; yours may be different.  I collected them using
> > "C-u C-x =" for characters whose presence makes display of HELLO
> > significantly slower.  If you don't have a font available for some
> > script and/or don't want that script's characters displayed, you can
> > replace the last argument of 'set-fontset-font' with nil, like I did
> > for 'burmese'.  (You can also use ranges of codepoints instead of
> > script symbols; see the doc string of 'set-fontset-font'.)
> >
> > The script of a character is also shown by "C-u C-x =".
> 
> How to get the correct second argument (script name?)

It is shown by "C-u C-x =".

> and also the "iso10646-1" (encoding name?)?

Always use iso10646-1, it makes no sense to use anything else with
these scripts.

> I do not find it in C-u C-x = and the manual is not very clear about
> that. Anyway, why Emacs can not generate a "suggestion" of
> set-fontset-font in the first place and tell user to add it into
> .emacs?

It does, in a way: look at the output of "C-u C-x =".  Besides, how is
Emacs to know that what happens on your system now is a permanent
setup?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 04:24:02 +0000
Resent-Message-ID: <handler.32159.B32159.153180139131971 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153180139131971
          (code B ref 32159); Tue, 17 Jul 2018 04:24:02 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 04:23:11 +0000
Received: from localhost ([127.0.0.1]:44332 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffHW2-0008Ja-QE
	for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 00:23:11 -0400
Received: from mail-wm0-f42.google.com ([74.125.82.42]:55310)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1ffHW0-0008JL-E0
 for 32159 <at> debbugs.gnu.org; Tue, 17 Jul 2018 00:23:08 -0400
Received: by mail-wm0-f42.google.com with SMTP id f21-v6so15063wmc.5
 for <32159 <at> debbugs.gnu.org>; Mon, 16 Jul 2018 21:23:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=JsuE0Od9GdYjjE4qMp050GEg5j9NWaMs8Wk54LYsU1M=;
 b=uo6A90lLiobel+3yDQ6/cdMXfMnj90c12q8BT+3bBTcyoJPDEreEHU5j2jimDZr53Q
 9VSohHQjBbbp7wP8+bfhuwp7/rZ2uoG85cgw3ZST2R1IQYRr8yEUJ9qqmfgam79Yn3Oo
 Nbsxwk+n17ZgYDqs69UErcQLO1V3makTIHFyMHJPbk2rNkm2neQCbujvsQEJLUDQXqZ2
 xRouWG7A62NmCHJecgFpH4w6jCXkRV9Xw6sZmY8m7PA+2t8dFQZF1Csdw1Rz7A+hwpuO
 6p/zF9hyVB+Xhv+mBlzAlbcp7IfUeyqUV3UlfqVzvxQcKeNBJy+efJpkGSAsMfNsXpKv
 IADQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=JsuE0Od9GdYjjE4qMp050GEg5j9NWaMs8Wk54LYsU1M=;
 b=VEUgytC/jZMzLReeAEcKt8RkIkQg1s72yfvejAskgaEU6a1gLSmfcUA5QPC9LtKaEt
 pLTH1B2mQwtdaKzi4BsRubsaNM+dARV9KNEpvyvRDMH8Mlal6eZNzZiV5CYsPggrGRwI
 A5Ye6DFC8IJYGtDHANr7MuS8TUkPamnQmCZylR6nRetrXOst/82cMWl3bfz1fXkNHW5t
 CR8gnuHI2x0GlvSI7GLugnqguRLq/VSZeEc9Jr76fMlmMsVlr5mUi007+5pPYuP/BmOg
 QbGJQhV0P849pfKIyB1vwfz0Ufp6qVoHk/afUZNbILtDuglY3YyYgNS5gDrSCvhwEDQc
 sEBg==
X-Gm-Message-State: AOUpUlHfiYcwIOLh+s7JM5qsD9oI5Hm4dI9k9J3pRmkMOdE2M0qUwTHK
 QSh7mcFpThsOylCtfMVVmYAqR22hepmpDTKc1A4=
X-Google-Smtp-Source: AAOMgpeRU+sM9YN7BLFhIC640WfNKqNosna+XufDRgNnWgN8fgJ2vsgq1UaWGius1MAUYGJJXGP3kGBqn/F+voIemD0=
X-Received: by 2002:a1c:eb08:: with SMTP id j8-v6mr219707wmh.160.1531801382319; 
 Mon, 16 Jul 2018 21:23:02 -0700 (PDT)
MIME-Version: 1.0
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
In-Reply-To: <83y3ea7ff4.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Tue, 17 Jul 2018 12:22:27 +0800
Message-ID: <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Tue, Jul 17, 2018 at 10:40 AM Eli Zaretskii <eliz@HIDDEN> wrote:
> > How to get the correct second argument (script name?)
> It is shown by "C-u C-x =".

OK. I see it now. The info is somewhat not obvious to me.

> > and also the "iso10646-1" (encoding name?)?
> Always use iso10646-1, it makes no sense to use anything else with
> these scripts.

How could a user know that? This should at least put into the manual.

> > I do not find it in C-u C-x = and the manual is not very clear about
> > that. Anyway, why Emacs can not generate a "suggestion" of
> > set-fontset-font in the first place and tell user to add it into
> > .emacs?
> It does, in a way: look at the output of "C-u C-x =".  Besides, how is
> Emacs to know that what happens on your system now is a permanent
> setup?

It needn't be a permanent setup. If Emacs loading time becomes longer
(for example, > 5 sec.), it should prompt users to change their
fontset and give suggestion settings again.
BTW, I still confused why Emacs needs to scan fonts to determine which
character belongs to which font. On the other hand, browsers like
Firefox, Chromium could display every script fonts very fast without
issue.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
In-Reply-To: <CAAYZpmQmB3q+fX=x2LQ3nR6vKsyNETHAYHobRYkPATge4Kbe2g@HIDDEN>
Resent-From: Andy Moreton <andrewjmoreton@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 10:25:01 +0000
Resent-Message-ID: <handler.32159.B.15318230778711 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 32159 <at> debbugs.gnu.org
X-Debbugs-Original-To: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.15318230778711
          (code B ref -1); Tue, 17 Jul 2018 10:25:01 +0000
Received: (at submit) by debbugs.gnu.org; 17 Jul 2018 10:24:37 +0000
Received: from localhost ([127.0.0.1]:44450 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffN9o-0002GR-OB
	for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 06:24:36 -0400
Received: from eggs.gnu.org ([208.118.235.92]:39181)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ffN9m-0002GE-JH
 for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 06:24:34 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ffN9g-0005cT-Dt
 for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 06:24:29 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:55085)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1ffN9g-0005cL-9s
 for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 06:24:28 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:58366)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ffN9f-0000fn-6h
 for bug-gnu-emacs@HIDDEN; Tue, 17 Jul 2018 06:24:28 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ffN9c-0005X3-1x
 for bug-gnu-emacs@HIDDEN; Tue, 17 Jul 2018 06:24:27 -0400
Received: from [195.159.176.226] (port=49621 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1ffN9b-0005SY-Q9
 for bug-gnu-emacs@HIDDEN; Tue, 17 Jul 2018 06:24:23 -0400
Received: from list by blaine.gmane.org with local (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ffN7N-00043D-Ih
 for bug-gnu-emacs@HIDDEN; Tue, 17 Jul 2018 12:22:05 +0200
X-Injected-Via-Gmane: http://gmane.org/
From: Andy Moreton <andrewjmoreton@HIDDEN>
Date: Tue, 17 Jul 2018 11:24:07 +0100
Lines: 36
Message-ID: <vz1efg22m9k.fsf@HIDDEN>
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default>
 <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1.50 (windows-nt)
Cancel-Lock: sha1:lCbNyzpFPGsLL37j2NHl94V5IzI=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.5 (----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.5 (-----)

On Tue 17 Jul 2018, Moses wrote:

> On Tue, Jul 17, 2018 at 10:40 AM Eli Zaretskii <eliz@HIDDEN> wrote:
>> > How to get the correct second argument (script name?)
>> It is shown by "C-u C-x =".
>
> OK. I see it now. The info is somewhat not obvious to me.
>
>> > and also the "iso10646-1" (encoding name?)?
>> Always use iso10646-1, it makes no sense to use anything else with
>> these scripts.

As a followup to the list Eli suggested, this works for me on Windows
10:

  (set-frame-font "DejaVu Sans Mono-9" nil t)
  (dolist (fontspec-targets
           '(;; Latin Extended Additional block (not supported by DejaVu Sans Mono)
             (("Liberation Mono"    . "iso10646-1") (#x1e00 . #x1eff))
             ;; Other scripts
             (("DejaVu Math Tex Gyre" . "iso10646-1") mathematical)
             (("Segoe UI Symbol"    . "iso10646-1") braille symbol)
             (("Myanmar Text"       . "iso10646-1") burmese)
             (("Ebrima"             . "iso10646-1") ethiopic)
             (("Microsoft Himalaya" . "iso10646-1") tibetan)
             (("Leelawadee UI"      . "iso10646-1") khmer thai)
             (("Gadugi"             . "iso10646-1") canadian-aboriginal cherokee)
             (("Nirmala UI"         . "iso10646-1") bengali devanagari gujarati
              kannada malayalam oriya sinhala tamil telugu)))
    (dolist (target (cdr fontspec-targets))
      (set-fontset-font "fontset-default" target (car fontspec-targets))))

That reduces the delay in showing the HELLO file from approx 20secs to
approx 3secs on my box.

    AndyM





Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 15:06:01 +0000
Resent-Message-ID: <handler.32159.B32159.153183993827017 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153183993827017
          (code B ref 32159); Tue, 17 Jul 2018 15:06:01 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 15:05:38 +0000
Received: from localhost ([127.0.0.1]:45621 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffRXm-00071g-3T
	for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:05:38 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56953)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ffRXk-00071S-At
 for 32159 <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:05:36 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ffRXa-0005tW-TR
 for 32159 <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:05:31 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:39657)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ffRXa-0005sL-JL; Tue, 17 Jul 2018 11:05:26 -0400
Received: from [176.228.60.248] (port=3041 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ffRXa-0001d5-2w; Tue, 17 Jul 2018 11:05:26 -0400
Date: Tue, 17 Jul 2018 18:05:36 +0300
Message-Id: <83tvox7vi7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 (message from Moses on Tue, 17 Jul 2018 12:22:27 +0800)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Tue, 17 Jul 2018 12:22:27 +0800
> Cc: drew.adams@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> > > and also the "iso10646-1" (encoding name?)?
> > Always use iso10646-1, it makes no sense to use anything else with
> > these scripts.
> 
> How could a user know that? This should at least put into the manual.

You can just drop the encoding, i.e. use

  (set-fontset-font "fontset-default" 'gujarati "Shruti")

The encoding part is just a precaution, and is nowadays only important
for some, hopefully rare, CJK use cases.  I used it in my example for
completeness' sake.

> > > I do not find it in C-u C-x = and the manual is not very clear about
> > > that. Anyway, why Emacs can not generate a "suggestion" of
> > > set-fontset-font in the first place and tell user to add it into
> > > .emacs?
> > It does, in a way: look at the output of "C-u C-x =".  Besides, how is
> > Emacs to know that what happens on your system now is a permanent
> > setup?
> 
> It needn't be a permanent setup.

Sorry, I'm not following: what you put on your ~/.emacs _is_ permanent
setup, in the sense that it will be in effect as long as you don't
change it.  It won't react to changes in the fonts you install, for
one thing.  If, for example, you are just trying some font, and didn't
yet decide whether you like it or not, suggesting that font for your
fontset customization will just confuse if not worse.

> If Emacs loading time becomes longer
> (for example, > 5 sec.), it should prompt users to change their
> fontset and give suggestion settings again.

First, the 5 sec figure is hard to decide on, because it depends on
many factors, like user impatience, the CPU speed, etc.

More importantly, if Emacs stops short of finding a font, it will not
have any useful suggestion for the actual setup of the fontset,
because it will not know what font to suggest.

But I think we are getting ahead of ourselves.  There could be a place
for user-level customization commands based on set-fontset-font
(although I envision non-trivial UI issues, due to the power and
flexibility of fontsets), but before we discuss that, we should
establish that customizing fontsets indeed fixes your real-life
problems.  That doing so for some fonts makes HELLO display faster
doesn't yet mean your real-life use cases are solved by doing the
same.

So please see if the problems that prompted your bug report are indeed
solved by customizing your fontset, including determining which
scripts/ranges of character codepoints needed such customization, and
let's defer the discussion of more user-friendly facilities to after
that.

> BTW, I still confused why Emacs needs to scan fonts to determine which
> character belongs to which font.

Not "belongs", but "can be displayed by".

And I don't think I understand your confusion: how else can any
program determine which font supports a given character, except by
checking the candidate fonts?

> On the other hand, browsers like Firefox, Chromium could display
> every script fonts very fast without issue.

I don't know how the browsers look for fonts.  If someone does, maybe
they can describe that, and we might then be able to learn something
useful.

Just for the record: I didn't write the code in Emacs that implements
font search, and have no real experience or expertise in that area, I
just know one or two things (literally) about what our code does.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 17 Jul 2018 15:53:02 +0000
Resent-Message-ID: <handler.32159.B32159.153184274331211 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Andy Moreton <andrewjmoreton@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153184274331211
          (code B ref 32159); Tue, 17 Jul 2018 15:53:02 +0000
Received: (at 32159) by debbugs.gnu.org; 17 Jul 2018 15:52:23 +0000
Received: from localhost ([127.0.0.1]:45645 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ffSH1-00087L-LN
	for submit <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:52:23 -0400
Received: from eggs.gnu.org ([208.118.235.92]:43831)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ffSGz-000878-8y
 for 32159 <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:52:21 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1ffSGq-00054d-Se
 for 32159 <at> debbugs.gnu.org; Tue, 17 Jul 2018 11:52:16 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:40566)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ffSGq-00054U-Oa; Tue, 17 Jul 2018 11:52:12 -0400
Received: from [176.228.60.248] (port=1990 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ffSGq-0003dN-5o; Tue, 17 Jul 2018 11:52:12 -0400
Date: Tue, 17 Jul 2018 18:52:22 +0300
Message-Id: <83muup7tc9.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <vz1efg22m9k.fsf@HIDDEN> (message from Andy Moreton on Tue, 17
 Jul 2018 11:24:07 +0100)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default>
 <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <vz1efg22m9k.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Tue, 17 Jul 2018 11:24:07 +0100
> 
> As a followup to the list Eli suggested, this works for me on Windows
> 10:
> 
>   (set-frame-font "DejaVu Sans Mono-9" nil t)
>   (dolist (fontspec-targets
>            '(;; Latin Extended Additional block (not supported by DejaVu Sans Mono)
>              (("Liberation Mono"    . "iso10646-1") (#x1e00 . #x1eff))
>              ;; Other scripts
>              (("DejaVu Math Tex Gyre" . "iso10646-1") mathematical)
>              (("Segoe UI Symbol"    . "iso10646-1") braille symbol)
>              (("Myanmar Text"       . "iso10646-1") burmese)
>              (("Ebrima"             . "iso10646-1") ethiopic)
>              (("Microsoft Himalaya" . "iso10646-1") tibetan)
>              (("Leelawadee UI"      . "iso10646-1") khmer thai)
>              (("Gadugi"             . "iso10646-1") canadian-aboriginal cherokee)
>              (("Nirmala UI"         . "iso10646-1") bengali devanagari gujarati
>               kannada malayalam oriya sinhala tamil telugu)))
>     (dolist (target (cdr fontspec-targets))
>       (set-fontset-font "fontset-default" target (car fontspec-targets))))
> 
> That reduces the delay in showing the HELLO file from approx 20secs to
> approx 3secs on my box.

Some of these fonts (DejaVu Math, at least) don't come with Windows
OOTB.  More importantly, most of the others are not free, which is why
we don't want to mention them in our default fontset.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 19 Jul 2018 13:43:01 +0000
Resent-Message-ID: <handler.32159.B32159.153200772719179 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: moses.mason@HIDDEN
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153200772719179
          (code B ref 32159); Thu, 19 Jul 2018 13:43:01 +0000
Received: (at 32159) by debbugs.gnu.org; 19 Jul 2018 13:42:07 +0000
Received: from localhost ([127.0.0.1]:47666 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fg9C2-0004zH-Uv
	for submit <at> debbugs.gnu.org; Thu, 19 Jul 2018 09:42:07 -0400
Received: from eggs.gnu.org ([208.118.235.92]:51108)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fg9C0-0004ym-Dk
 for 32159 <at> debbugs.gnu.org; Thu, 19 Jul 2018 09:42:04 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1fg9Br-0007PP-V5
 for 32159 <at> debbugs.gnu.org; Thu, 19 Jul 2018 09:41:59 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:53641)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1fg9Br-0007PL-Pi; Thu, 19 Jul 2018 09:41:55 -0400
Received: from [176.228.60.248] (port=2033 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1fg9Bo-00042t-Sd; Thu, 19 Jul 2018 09:41:54 -0400
Date: Thu, 19 Jul 2018 16:41:52 +0300
Message-Id: <83fu0f2vhb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <83tvox7vi7.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 17
 Jul 2018 18:05:36 +0300)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> Date: Tue, 17 Jul 2018 18:05:36 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 32159 <at> debbugs.gnu.org
> 
> > On the other hand, browsers like Firefox, Chromium could display
> > every script fonts very fast without issue.
> 
> I don't know how the browsers look for fonts.  If someone does, maybe
> they can describe that, and we might then be able to learn something
> useful.

I've dug a little, and it looks like Firefox simply hard-codes an
explicit font name or a short list of explicit font names for every
"language" (what we call "script").  The defaults change whenever
Firefox developers decide that a better font is available on the
particular OS OOTB, or when a new version of the OS adds fonts.  To
see the defaults, type "about:config" into the address bar, and look
at the font.name-list.* variables.  The user can customize this (via
Options, hidden under "Fonts & Colors -> Advanced") by specifying a
single font for each script+style combination (where "style" is one of
Serif, Sans-Serif, and Monospaced).

Chrome seems to do something very similar, except that its defaults
are less sophisticated (many scripts don't have fonts defined and use
the global default font).

The advantage of this method is that it avoids font search in the
cases where by default there's only one font per script (slightly less
than 50% of the scripts in my version of Firefox), and makes the
search shorter when there are several candidate scripts in the
list.  The disadvantages are:

 . When the user installs a font that doesn't come with the OS OOTB,
   the only way to start using that font is to customize the defaults
   via Options.  Likewise, when a non-standard font is uninstalled
   that was previously customized to be used by Firefox.

 . The defaults explicitly name fonts installed on the OS, so for
   non-free systems, such as Windows, and maybe also for free systems,
   they name non-free fonts.  That is something we try very hard to
   avoid in our defaults, AFAIU.

Emacs defaults usually do not specify fonts explicitly (with a few
exceptions), but instead specify features that a font must have in
order to be considered for characters belonging to a script.  This
allows the user significant more flexibility, since which font will be
used is determined by the installed fonts, and does not require
customization after installed fonts change.  But the price is a
potentially longer search for a font, especially when a lot of fonts
are available on the system.

We could do something similar to what the browsers do, if we want, at
least on Free systems, but Someone™ would have to do the footwork of
looking at enough boxes and collecting free fonts that are available
OOTB there.  This could at least be an optional feature, for those who
don't intend changing their installed fonts too much, or not at all.
For non-free systems, the corresponding settings could be perhaps on
the wiki (and again, Someone™ should do the research and publish the
results).




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Drew Adams <drew.adams@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 19 Jul 2018 15:57:02 +0000
Resent-Message-ID: <handler.32159.B32159.15320158047915 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>, moses.mason@HIDDEN
Cc: 32159 <at> debbugs.gnu.org
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15320158047915
          (code B ref 32159); Thu, 19 Jul 2018 15:57:02 +0000
Received: (at 32159) by debbugs.gnu.org; 19 Jul 2018 15:56:44 +0000
Received: from localhost ([127.0.0.1]:48444 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fgBIK-00023a-5q
	for submit <at> debbugs.gnu.org; Thu, 19 Jul 2018 11:56:44 -0400
Received: from userp2120.oracle.com ([156.151.31.85]:43626)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1fgBII-00023L-Di
 for 32159 <at> debbugs.gnu.org; Thu, 19 Jul 2018 11:56:42 -0400
Received: from pps.filterd (userp2120.oracle.com [127.0.0.1])
 by userp2120.oracle.com (8.16.0.22/8.16.0.22) with SMTP id w6JFsKLo123654;
 Thu, 19 Jul 2018 15:56:36 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2018-07-02;
 bh=7F/0vVcg30LNIYBAMpHu2TLXf7jUlFWUmgddoAOVTCs=;
 b=CCfs8IZJ8dVyr2iv7PvPghBlRzSYp4vMpmOuJ8kwlXkx+tAxqTHsSOoXz+X8YcVA2SlW
 k7Ut782uWsGGG5tWFzt8vhyl8MVPqKdVXZkiia/+XhgtcoQo/eKS/s3S27qdRnurdBZ+
 HUI9J/jk8/FKY15W2hcNVzD9sKVBsoQAz7DI9lPWqQas5b6j9HucQU8cQyBxVigFGUao
 WtgC6HJAOPtbbvSuwp+5NfugIm2cCtc+BypvRBjKLFFFN4n1VhXbmndfrmOcDzVZHc4G
 uCbb5EreCt0vtygIpXadEXR/qH7qf6GTKTG6a3oncIgd5fHlKgK1KJQp9u31RvqOEWp8 7w== 
Received: from userv0021.oracle.com (userv0021.oracle.com [156.151.31.71])
 by userp2120.oracle.com with ESMTP id 2k9yjx7sgm-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Thu, 19 Jul 2018 15:56:36 +0000
Received: from aserv0122.oracle.com (aserv0122.oracle.com [141.146.126.236])
 by userv0021.oracle.com (8.14.4/8.14.4) with ESMTP id w6JFuZ0d000346
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Thu, 19 Jul 2018 15:56:35 GMT
Received: from abhmp0001.oracle.com (abhmp0001.oracle.com [141.146.116.7])
 by aserv0122.oracle.com (8.14.4/8.14.4) with ESMTP id w6JFuYFx002953;
 Thu, 19 Jul 2018 15:56:34 GMT
MIME-Version: 1.0
Message-ID: <02da5127-384a-4874-a342-2fd9d2d8251b@default>
Date: Thu, 19 Jul 2018 08:56:29 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN> <83fu0f2vhb.fsf@HIDDEN>
In-Reply-To: <83fu0f2vhb.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4717.0 (x86)]
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=5900 definitions=8958
 signatures=668706
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=683
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1806210000 definitions=main-1807190168
X-Spam-Score: -2.3 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I've dug a little, and it looks like...

I just want to thank you for doing that.  And for providing
a clear description of what you found out.  Kudos.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 05:47:02 +0000
Resent-Message-ID: <handler.32159.B32159.15322383933080 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15322383933080
          (code B ref 32159); Sun, 22 Jul 2018 05:47:02 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 05:46:33 +0000
Received: from localhost ([127.0.0.1]:51516 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fh7CS-0000nb-Pn
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 01:46:33 -0400
Received: from mail-wr1-f54.google.com ([209.85.221.54]:39813)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1fh7CO-0000nJ-U9
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 01:46:29 -0400
Received: by mail-wr1-f54.google.com with SMTP id h10-v6so14738546wre.6
 for <32159 <at> debbugs.gnu.org>; Sat, 21 Jul 2018 22:46:28 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=0qqp48WRhiJXIpOzBKSfmZND+bZCYHjG/iuHxKO3SNQ=;
 b=Sz5b19lkd8a4Cv+H3DT/A92UNYvAkmqbCN552htr5mLXpzhtKeDZ2p2ah1v3jUyEZb
 elkYW60uno3AiMwMezGYzBS0882rYNY8/PmVg2ha+W6sc4xNMW2aMKKYJfZqZhmRfs5F
 +cpHC7MWUjI4QkJIAE0DCch6weh97k+x1YgWhW58wjgKEi2r6bREmklM2RHs3Jge2f+R
 olMZTRbE3ZVH0X/BZdrNmEvfiRhF1wpPipiJ1f3YIWD9RmliDf23v9WlwYuRjIL/b47/
 IL4vhzOYfyfZtCq4IoKtVzhSEJjuUoE9Hjrco9VMBQNuaCx7V8wxCz4oJuGMeQK9OWrQ
 7dcA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=0qqp48WRhiJXIpOzBKSfmZND+bZCYHjG/iuHxKO3SNQ=;
 b=R7He7VX3R2HuynPcj0aqH5DnfrH16VkyrdlhOkqIR4YK+L0qjmEktUvVDZMGfhU7zi
 EjfQPoeI5WD1ls5XcfPs2TWgjtYFhSSfpvIaGgmNfKkv279ZfeVpzFCTHrNPs46IGw3D
 HdUbiQyy7Tr36iipwiZM8eDJl+hYm57x+8SzGbXUEGecp54Zs/E13aGvjWKM5K6T20Yb
 VSbB6epts1yTG1tdxy8Zv0nUHKOTP3VklFKiYvSn7A0yXK1MwQB9f8C573laNdZHRhhr
 wk7DzuQQqGks8jXcrya0KuNsEGXa7fAAtQ4gYcN4RsleYz7H3oj0f/3h0YMDtl47736b
 TzPw==
X-Gm-Message-State: AOUpUlFdb5tJx6BfXbjM4uAWYqGOlo3yqWlJI2pDfZXtQrIN0gFX8Syl
 8dLbh/L/bD3vLZovCr52mayWaTOxx8L8qMkCHyw=
X-Google-Smtp-Source: AAOMgpdtoDpz2p5bx7CK/5MS8hTe9VzPxOkRNubm+i6GZPAMJys/kUDLcElJJeHhX1GBy6V7OpJD7kd4R6KAyiweXnQ=
X-Received: by 2002:adf:ed41:: with SMTP id
 u1-v6mr5060999wro.262.1532238383135; 
 Sat, 21 Jul 2018 22:46:23 -0700 (PDT)
MIME-Version: 1.0
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
In-Reply-To: <83tvox7vi7.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Sun, 22 Jul 2018 05:45:46 +0000
Message-ID: <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Tue, Jul 17, 2018 at 11:05 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> More importantly, if Emacs stops short of finding a font, it will not
> have any useful suggestion for the actual setup of the fontset,
> because it will not know what font to suggest.

Maybe Emacs can prompt the user to find/download the fonts that missing?


> But I think we are getting ahead of ourselves.  There could be a place
> for user-level customization commands based on set-fontset-font
> (although I envision non-trivial UI issues, due to the power and
> flexibility of fontsets), but before we discuss that, we should
> establish that customizing fontsets indeed fixes your real-life
> problems.  That doing so for some fonts makes HELLO display faster
> doesn't yet mean your real-life use cases are solved by doing the
> same.
>
> So please see if the problems that prompted your bug report are indeed
> solved by customizing your fontset, including determining which
> scripts/ranges of character codepoints needed such customization, and
> let's defer the discussion of more user-friendly facilities to after
> that.

After many failed tries. I finally make Emacs a little faster after
customized the fontset. I have to find the font name and the script
name for each script. It a painful process. Maybe it is not Emacs'
fault, but I hope the customizing process could be automatically done.

The HELLO file opening still slow though.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 14:07:02 +0000
Resent-Message-ID: <handler.32159.B32159.15322684121019 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15322684121019
          (code B ref 32159); Sun, 22 Jul 2018 14:07:02 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 14:06:52 +0000
Received: from localhost ([127.0.0.1]:52470 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhF0e-0000GM-Kd
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 10:06:52 -0400
Received: from eggs.gnu.org ([208.118.235.92]:57033)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fhF0c-0000G8-By
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 10:06:50 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1fhF0S-0007it-Qt
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 10:06:45 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:47082)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1fhF0S-0007ip-MP; Sun, 22 Jul 2018 10:06:40 -0400
Received: from [176.228.60.248] (port=4046 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1fhF0S-0007Pz-9j; Sun, 22 Jul 2018 10:06:40 -0400
Date: Sun, 22 Jul 2018 17:06:44 +0300
Message-Id: <8336wbxt3f.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
 (message from Moses on Sun, 22 Jul 2018 05:45:46 +0000)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
 <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Sun, 22 Jul 2018 05:45:46 +0000
> Cc: drew.adams@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> On Tue, Jul 17, 2018 at 11:05 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> > More importantly, if Emacs stops short of finding a font, it will not
> > have any useful suggestion for the actual setup of the fontset,
> > because it will not know what font to suggest.
> 
> Maybe Emacs can prompt the user to find/download the fonts that missing?

We could prompt, but without telling the names of the required fonts,
how useful would be such a prompt?  All we know is a script, and maybe
some other attributes.  How many users will know what fonts to look
for and download?

Also, in quite a few cases the problem is not that a font is not
available, the problem is that there are too many fonts to try before
Emacs gets to one that can display a character.

> > So please see if the problems that prompted your bug report are indeed
> > solved by customizing your fontset, including determining which
> > scripts/ranges of character codepoints needed such customization, and
> > let's defer the discussion of more user-friendly facilities to after
> > that.
> 
> After many failed tries. I finally make Emacs a little faster after
> customized the fontset.

Can you try to make this a little more quantitative?  How long did it
take before and how long after the fontset customizations?  And why
did you need many failed trials, what was the problem that prevented
you from succeeding on the first trial?

> I have to find the font name and the script name for each script. It
> a painful process.

Which scripts are the ones for which you needed to customize the
fontset?  I mean in your real-life use cases, not for displaying
HELLO.

> The HELLO file opening still slow though.

You mean, customizing the fontset didn't help with HELLO?  Is it
possible that you customized the fontset for scripts other than those
which slow down HELLO?

Thanks.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 14:54:02 +0000
Resent-Message-ID: <handler.32159.B32159.15322712205441 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15322712205441
          (code B ref 32159); Sun, 22 Jul 2018 14:54:02 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 14:53:40 +0000
Received: from localhost ([127.0.0.1]:52529 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhFjw-0001Ph-E5
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 10:53:40 -0400
Received: from mail-wr1-f53.google.com ([209.85.221.53]:45001)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1fhFju-0001PQ-9u
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 10:53:38 -0400
Received: by mail-wr1-f53.google.com with SMTP id r16-v6so15414497wrt.11
 for <32159 <at> debbugs.gnu.org>; Sun, 22 Jul 2018 07:53:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=yBzGwPSQeDhDUGTAbU2a19O+GPp6bajp13cIVHqKJHQ=;
 b=amE7ZaARHlS4WG2/tEDOvgGD+9dPZpLA1OfPwIw9Wfe1+WlUw0jQi86RwRva2FkMKI
 Lx/6nd0TWdPwnFNBmuVDM4AJ+CCZNOlY2Eyn+796TFwLNn5FRCkXPJTRr19ea8RgIBzb
 CJkWPyEbkfWlY6gTrAkCk8UbC47yqYfY7cqCD+U6avqStKBkMNDL8r6upSwxHMMt9key
 z/5S3mXp/X2SKM7Xrb+Ww01sYBfjqkwNXIFs8GNHgP6XnXPhz+aR5a2ZQmYFgLdPEaeh
 EFxZCDEQFmgJH27tk0bOtpaGmB5sso5aZ/VgEb4LBvXRdxJ6VnshcBkAbAIAbavSArd8
 SPxg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=yBzGwPSQeDhDUGTAbU2a19O+GPp6bajp13cIVHqKJHQ=;
 b=sh9q17gjZGvCpQWA9fmnelZnTFM64EWPe7eOIzt8B9P/u5n2zgM4P8RuNaEaY3d8IH
 XZSbrEHotkGZUWdrupY+PhGkTkFgKsspu4ZbCAGh6SE2R23jGlAqw1yrYHhO2fjdbf79
 vAOjiuJnasxtVgaoMpNVJuGo5ed4O5h4cgSZC9iB8uw73JzU9E+AA7Ajuqw/KSBZSqUy
 07lRSSIf6dPYM6Uh0CPIBJS6WVNKnN4IlZyUJHbA5o0pVUULhPP2FMVjvlXZLi94MXWM
 oUxTRFxsCva3dIqwBcmEDTg9dgRVTjfpOhWQaHTkgF7P+CUhdcN2MAWZC8G0GceH//fg
 EyfA==
X-Gm-Message-State: AOUpUlFN3n2Wq8eOvxSnF6T2pyXFMNOG2XZPKAZ0UUAxBg76dn8yJ1Yj
 LApM2Yy1ASaSWw/Zm5RmcSrZpI1z1yzVNHvadE8=
X-Google-Smtp-Source: AAOMgpdXww/FY5q0RpYqwMltEX/Ux1v4UdJZVrY6oJnRxVQ/1ZOyz/s/qfACiGA2L25vpMO9BJpq5NQSpFXM3acaMM0=
X-Received: by 2002:a5d:4306:: with SMTP id h6-v6mr6295540wrq.58.1532271212461; 
 Sun, 22 Jul 2018 07:53:32 -0700 (PDT)
MIME-Version: 1.0
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
 <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
 <8336wbxt3f.fsf@HIDDEN>
In-Reply-To: <8336wbxt3f.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Sun, 22 Jul 2018 14:52:54 +0000
Message-ID: <CAAYZpmQ46vZfGAquJs4p_xwBDWukYNO-vZEyAivKNbXMapRPeA@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, Jul 22, 2018 at 2:06 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> Can you try to make this a little more quantitative?  How long did it
> take before and how long after the fontset customizations?

Gnus was usually stopped responding and lagging several seconds when
scrolling before the fontset customization. It is much better now.

> And why
> did you need many failed trials, what was the problem that prevented
> you from succeeding on the first trial?

I need to pair every fonts name and script name for every
script/language but I do not know the font name for some
scripts/languages. So I leave Emacs to find the correct font and use
M-x descript-char on these language's character to find the font name.
When there are many languages, it takes some time. And I also found I
made some mistake before, so I need to delete the incorrect one and
repeat these step for that specific script/language again.

> Which scripts are the ones for which you needed to customize the
> fontset?  I mean in your real-life use cases, not for displaying
> HELLO.

This is my font setting, the Linux part is not complete, because
currently, I am on my Windows box.

;; font
(setq font-encoding-alist
(append '(("gb2312.1980" . chinese-gbk)
   ("iso8859-1$" . iso-8859-1)
   ("iso8859-2$" . iso-8859-2)
   ("iso8859-3$" . iso-8859-3)
   ("iso8859-4$" . iso-8859-4)
   ("iso8859-5$" . iso-8859-5)
   ("iso8859-6$" . iso-8859-6)
   ("iso8859-7$" . iso-8859-7)
   ("iso8859-8$" . iso-8859-8)
   ("iso8859-9$" . iso-8859-9)
   ("iso8859-10$" . iso-8859-10)
   ("iso8859-11$" . iso-8859-11)
   ("iso8859-13$" . iso-8859-13)
   ("iso8859-14$" . iso-8859-14)
   ("iso8859-15$" . iso-8859-15)
   ("iso8859-16$" . iso-8859-16)
   ("ascii-0$" . ascii)
   ("gb2312.1980" . chinese-gb2312)
   ("gbk" . chinese-gbk)
   ("gb18030" unicode)
   ("jisx0208.1978" . japanese-jisx0208-1978)
   ("jisx0208" . japanese-jisx0208)
   ("jisx0201" . jisx0201)
   ("jisx0212" . japanese-jisx0212)
   ("ksx1001" . korean-ksc5601)
   ("ksc5601.1987" . korean-ksc5601)
   ("cns11643.1992.*1" . chinese-cns11643-1)
   ("cns11643.1992.*2" . chinese-cns11643-2)
   ("cns11643.1992.*3" . chinese-cns11643-3)
   ("cns11643.1992.*4" . chinese-cns11643-4)
   ("cns11643.1992.*5" . chinese-cns11643-5)
   ("cns11643.1992.*6" . chinese-cns11643-6)
   ("cns11643.1992.*7" . chinese-cns11643-7)
   ("cns11643.92p1-0" . chinese-cns11643-1)
   ("cns11643.92p2-0" . chinese-cns11643-2)
   ("cns11643.92p3-0" . chinese-cns11643-3)
   ("cns11643.92p4-0" . chinese-cns11643-4)
   ("cns11643.92p5-0" . chinese-cns11643-5)
   ("cns11643.92p6-0" . chinese-cns11643-6)
   ("cns11643.92p7-0" . chinese-cns11643-7)
   ("big5" . big5)
   ("viscii" . viscii)
   ("tis620" . tis620-2533)
   ("microsoft-cp1251" . windows-1251)
   ("koi8-r" . koi8-r)
   ("jisx0213.2000-1" . japanese-jisx0213-1)
   ("jisx0213.2000-2" . japanese-jisx0213-2)
   ("jisx0213.2004-1" . japanese-jisx0213\.2004-1)
   ("iso10646-1$" unicode-bmp)
   ("iso10646.indian-1" unicode-bmp)
   ("unicode-bmp" unicode-bmp)
   ("abobe-symbol" . symbol)
   ("sisheng_cwnn" . chinese-sisheng)
   ("mulearabic-0" . arabic-digit)
   ("mulearabic-1" . arabic-1-column)
   ("mulearabic-2" . arabic-2-column)
   ("muleipa" . ipa)
   ("ethiopic-unicode" unicode-bmp . ethiopic)
   ("is13194-devanagari" . indian-is13194)
   ("Devanagari-CDAC" . devanagari-cdac)
   ("Sanskrit-CDAC" . sanskrit-cdac)
   ("Bengali-CDAC" . bengali-cdac)
   ("Assamese-CDAC" . assamese-cdac)
   ("Punjabi-CDAC" . punjabi-cdac)
   ("Gujarati-CDAC" . gujarati-cdac)
   ("Oriya-CDAC" . oriya-cdac)
   ("Tamil-CDAC" . tamil-cdac)
   ("Telugu-CDAC" . telugu-cdac)
   ("Kannada-CDAC" . kannada-cdac)
   ("Malayalam-CDAC" . malayalam-cdac)
   ("Devanagari-Akruti" . devanagari-akruti)
   ("Bengali-Akruti" . bengali-akruti)
   ("Punjabi-Akruti" . punjabi-akruti)
   ("Gujarati-Akruti" . gujarati-akruti)
   ("Oriya-Akruti" . oriya-akruti)
   ("Tamil-Akruti" . tamil-akruti)
   ("Telugu-Akruti" . telugu-akruti)
   ("Kannada-Akruti" . kannada-akruti)
   ("Malayalam-Akruti" . malayalam-akruti)
   ("muleindian-2" . indian-2-column)
   ("muleindian-1" . indian-1-column)
   ("mulelao-1" . mule-lao)
   ("muletibetan-2" . tibetan)
   ("muletibetan-0" . tibetan)
   ("muletibetan-1" . tibetan-1-column))
font-encoding-alist)
)

(defun my--set-font (&optional frame)
  (with-selected-frame (or frame (selected-frame))
    (if (string-equal system-type "windows-nt")
;; Windows
(progn
  (set-face-attribute 'default nil :font "consolas")
  (dolist (charset '(han cjk-misc chinese-gbk))
    (set-fontset-font "fontset-default" charset (font-spec :family
"Microsoft Jhenghei")))
    (set-fontset-font "fontset-default" 'kana '("Meiryo" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'hangul '("Malgun Gothic" .
"iso10646-1"))
    (set-fontset-font "fontset-default" 'arabic '("Adobe Naskh Medium"
. "iso10646-1"))
    (set-fontset-font "fontset-default" 'cyrillic '("Consolas" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'gujarati '("Nirmala UI" .
"iso10646-1"))
    (set-fontset-font "fontset-default" 'devanagari '("Adobe
Devanagari" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'kannada '("Nirmala UI" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'malayalam '("Nirmala UI" .
"iso10646-1"))
    (set-fontset-font "fontset-default" 'oriya '("Nirmala UI" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'sinhala '("Nirmala UI" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'tamil '("Nirmala UI" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'telugu '("Nirmala UI" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'tibetan '("Microsoft
Himalaya" . "iso10646-1"))
    (set-fontset-font "fontset-default" 'burmese '("Myanmar Text" .
"iso10646-1"))


  (setq use-default-font-for-symbols nil)

  (set-fontset-font "fontset-default" 'unicode "Segoe UI Symbol" nil 'append)
  (set-fontset-font "fontset-default" '(#x1F600 . #x1F64F) "Segoe UI
Symbol") ; Emoji
  (set-fontset-font "fontset-default" '(#xE000 . #xF8FF) "STIX")) ;
Private Use Areas
      ;; Linux
      (set-face-attribute
       'default nil :font "Inconsolata 14")
      (dolist (charset '(kana han cjk-misc bopomofo))
(set-fontset-font "fontset-default"
  charset (font-spec :name "Hiragino Sans GB")))))

  (set-fontset-font "fontset-default" 'egyptian '("Noto Sans Egyptian
Hieroglyphs" . "iso10646-1"))
  (set-fontset-font "fontset-default" 'javanese '("Javanese Text" .
"iso10646-1"))
  )

(my--set-font)

(add-hook 'after-make-frame-functions 'my--set-font)

(setq inhibit-compacting-font-caches t)

;; font size
(set-face-attribute 'default nil :height 120)




> You mean, customizing the fontset didn't help with HELLO?  Is it
> possible that you customized the fontset for scripts other than those
> which slow down HELLO?

As you can see, some fontset settings were taken from your previous
post. I only modified the font name to adjust my machine, other parts
is my own. I believe this setup covers all the characters range in the
HELLO file?


> Thanks.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 15:15:02 +0000
Resent-Message-ID: <handler.32159.B32159.15322724637604 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.15322724637604
          (code B ref 32159); Sun, 22 Jul 2018 15:15:02 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 15:14:23 +0000
Received: from localhost ([127.0.0.1]:52569 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhG3z-0001yZ-7l
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 11:14:23 -0400
Received: from eggs.gnu.org ([208.118.235.92]:38951)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fhG3x-0001yM-FK
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 11:14:21 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1fhG3n-0005N8-Tb
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 11:14:16 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.5 required=5.0 tests=BAYES_05 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:48047)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1fhG3n-0005Mw-Qa; Sun, 22 Jul 2018 11:14:11 -0400
Received: from [176.228.60.248] (port=4263 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1fhG3n-0008ET-AY; Sun, 22 Jul 2018 11:14:11 -0400
Date: Sun, 22 Jul 2018 18:14:15 +0300
Message-Id: <83r2jvwbeg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmQ46vZfGAquJs4p_xwBDWukYNO-vZEyAivKNbXMapRPeA@HIDDEN>
 (message from Moses on Sun, 22 Jul 2018 14:52:54 +0000)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
 <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
 <8336wbxt3f.fsf@HIDDEN>
 <CAAYZpmQ46vZfGAquJs4p_xwBDWukYNO-vZEyAivKNbXMapRPeA@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Sun, 22 Jul 2018 14:52:54 +0000
> Cc: drew.adams@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> On Sun, Jul 22, 2018 at 2:06 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> > Can you try to make this a little more quantitative?  How long did it
> > take before and how long after the fontset customizations?
> 
> Gnus was usually stopped responding and lagging several seconds when
> scrolling before the fontset customization. It is much better now.

OK, so it did help.

> This is my font setting, the Linux part is not complete, because
> currently, I am on my Windows box.
> 
> ;; font
> (setq font-encoding-alist
> (append '(("gb2312.1980" . chinese-gbk)
>    ("iso8859-1$" . iso-8859-1)

You don't need to copy the entire font-encoding-alist, you just need
to replace the gb2312.1980 association there.

> > You mean, customizing the fontset didn't help with HELLO?  Is it
> > possible that you customized the fontset for scripts other than those
> > which slow down HELLO?
> 
> As you can see, some fontset settings were taken from your previous
> post. I only modified the font name to adjust my machine, other parts
> is my own. I believe this setup covers all the characters range in the
> HELLO file?

The setup I posted only covered a few scripts that were slowing down
things on my system.  It doesn't cover all of the scripts, as I didn't
need that.

So what else needs to be done for this bug report?  Do we still have
issues that need to be resolved?

Thanks.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Moses <moses.mason@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 15:43:01 +0000
Resent-Message-ID: <handler.32159.B32159.153227416225623 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153227416225623
          (code B ref 32159); Sun, 22 Jul 2018 15:43:01 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 15:42:42 +0000
Received: from localhost ([127.0.0.1]:52614 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhGVN-0006fD-PQ
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 11:42:41 -0400
Received: from mail-wm0-f44.google.com ([74.125.82.44]:34255)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <moses.mason@HIDDEN>) id 1fhGVM-0006f1-SH
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 11:42:41 -0400
Received: by mail-wm0-f44.google.com with SMTP id l2-v6so7871354wme.1
 for <32159 <at> debbugs.gnu.org>; Sun, 22 Jul 2018 08:42:40 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=XjsmpOGEqH9ns5VRzAGvCZm3u/KWkY9EcxbdV6jATg0=;
 b=XFkZrM6VNyQswABOVLYyzHuXqnzzM9nE5S2oMI3zb6AstwouA0zI9PwUotpFZLr20A
 Ah+fsGo0bigVGECNSlT7+bQiU6FR87GbaoQCXdSyBXR9aAe6VgtLjnD0mxWbsmQSYhal
 ag++6e05UALNMU1JINRpRINVMw1rrQeZp+tNE43fCZdm9weLYExBnF5JaMIuddcjRHOF
 T9nYC8NMW8et2HaJgpbAG88RaTBzGhV9ccQO8tScxnc40x9+F0yfnUu5SRiS/Zj/rCrW
 MkSdj4mH/GqX0kEASt1z8YTgQDXMVB4pOo7LEHWnm0PQKcV7Guz0wYyg800mLDQoJomw
 YykQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=XjsmpOGEqH9ns5VRzAGvCZm3u/KWkY9EcxbdV6jATg0=;
 b=Pm9qhhfqR40PfmNW+gB3h8nU3FzZg9yaPkfVcqwDBZAfoFgiOFC613c66DeKRaJm+Z
 hasfDC+DXL6eZy1uWW6HhrWTqyItJao/8ySNgPhzcSBM6ls3O4avZ0/GP7pB+ju71T97
 S9zmJ2rI934ci71Af4xXzLpIRKseACR8D1FNh+O9vDxUiOy6wlGG3FyRvL+zUFUIIXBz
 D4YxV/rNevqb2Mf8WKbQlLswi9e6W0YTaYv/c/WaadFSL29LsKh7rUVXZHCVpZCp0uYo
 v9Hs3T3HWRkPm9uNhOGXUgn5K7ng4hf01FWgmto+Qw2WzRGN2XHKUufK6D8wDpYSwuVF
 Fzsg==
X-Gm-Message-State: AOUpUlGhxnKLXcKw4VWN2DTRI3TeeHMDeh+OzOVQjWFS1K6xwO4X4+MU
 IhXiH9GxoamuiHCSJVBKzJw5BTWsrBQ6VIq5Gv8=
X-Google-Smtp-Source: AAOMgpdOHcs+y2H1Z3GOpmOwaCo6lKL6kY4jsKXE+NV1iRnmKYlTqIvfGVZwZ3pp/L/x9+GkWWER0D54uGupGEHDQi8=
X-Received: by 2002:a1c:7408:: with SMTP id
 p8-v6mr5400947wmc.118.1532274155080; 
 Sun, 22 Jul 2018 08:42:35 -0700 (PDT)
MIME-Version: 1.0
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
 <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
 <8336wbxt3f.fsf@HIDDEN>
 <CAAYZpmQ46vZfGAquJs4p_xwBDWukYNO-vZEyAivKNbXMapRPeA@HIDDEN>
 <83r2jvwbeg.fsf@HIDDEN>
In-Reply-To: <83r2jvwbeg.fsf@HIDDEN>
From: Moses <moses.mason@HIDDEN>
Date: Sun, 22 Jul 2018 15:41:58 +0000
Message-ID: <CAAYZpmTiRwD0NAiSVCDkKDdPPR6nuhALaS4fy-3e53Z0DS7mZQ@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, Jul 22, 2018 at 3:14 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> The setup I posted only covered a few scripts that were slowing down
> things on my system.  It doesn't cover all of the scripts, as I didn't
> need that.
>
> So what else needs to be done for this bug report?  Do we still have
> issues that need to be resolved?

Maybe the fontset customization needs more user-friendly and
automatically. It is not obvious which script is slowing down Emacs.

Thank you for your help.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#32159: 26.1; inhibit-compacting-font-caches does not fix all fonts lagging issue
Resent-From: Eli Zaretskii <eliz@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 22 Jul 2018 16:03:01 +0000
Resent-Message-ID: <handler.32159.B32159.153227535327403 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 32159
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Moses <moses.mason@HIDDEN>
Cc: 32159 <at> debbugs.gnu.org, drew.adams@HIDDEN
Received: via spool by 32159-submit <at> debbugs.gnu.org id=B32159.153227535327403
          (code B ref 32159); Sun, 22 Jul 2018 16:03:01 +0000
Received: (at 32159) by debbugs.gnu.org; 22 Jul 2018 16:02:33 +0000
Received: from localhost ([127.0.0.1]:52622 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhGob-00077v-4r
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 12:02:33 -0400
Received: from eggs.gnu.org ([208.118.235.92]:46701)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1fhGoY-00077h-Re
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 12:02:31 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1fhGoQ-0001JQ-JT
 for 32159 <at> debbugs.gnu.org; Sun, 22 Jul 2018 12:02:25 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:48500)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1fhGoQ-0001JJ-Fy; Sun, 22 Jul 2018 12:02:22 -0400
Received: from [176.228.60.248] (port=3225 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1fhGoP-0006FT-Qy; Sun, 22 Jul 2018 12:02:22 -0400
Date: Sun, 22 Jul 2018 19:02:26 +0300
Message-Id: <83muujw965.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
In-reply-to: <CAAYZpmTiRwD0NAiSVCDkKDdPPR6nuhALaS4fy-3e53Z0DS7mZQ@HIDDEN>
 (message from Moses on Sun, 22 Jul 2018 15:41:58 +0000)
References: <83muut9q8m.fsf@HIDDEN>
 <CAAYZpmRMJW9bVisJRLja0yEg-rKQ0z3XYfSHanw0ZD7ubVQoFg@HIDDEN>
 <45c210aa-5a57-45f7-9bd4-752876b233c2@default> <8336wj9s5d.fsf@HIDDEN>
 <CAAYZpmRWP1a0vP+Zh3WymW__hkag1x-LYuOM+zFEsvs-b1kj4A@HIDDEN>
 <83y3ea7ff4.fsf@HIDDEN>
 <CAAYZpmS2AiMGR56ZTMQjTa3dodtMEvG7Gkw3xXphDFQHO5Gr+A@HIDDEN>
 <83tvox7vi7.fsf@HIDDEN>
 <CAAYZpmTCX36Fa2L5qr=aO7t6S=TBpnYM2FHGFkDK-FB=RmTS1A@HIDDEN>
 <8336wbxt3f.fsf@HIDDEN>
 <CAAYZpmQ46vZfGAquJs4p_xwBDWukYNO-vZEyAivKNbXMapRPeA@HIDDEN>
 <83r2jvwbeg.fsf@HIDDEN>
 <CAAYZpmTiRwD0NAiSVCDkKDdPPR6nuhALaS4fy-3e53Z0DS7mZQ@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

> From: Moses <moses.mason@HIDDEN>
> Date: Sun, 22 Jul 2018 15:41:58 +0000
> Cc: drew.adams@HIDDEN, 32159 <at> debbugs.gnu.org
> 
> On Sun, Jul 22, 2018 at 3:14 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> > The setup I posted only covered a few scripts that were slowing down
> > things on my system.  It doesn't cover all of the scripts, as I didn't
> > need that.
> >
> > So what else needs to be done for this bug report?  Do we still have
> > issues that need to be resolved?
> 
> Maybe the fontset customization needs more user-friendly and
> automatically. It is not obvious which script is slowing down Emacs.

For that, we'd need a machinery to find out which fonts are the cause
of slowdown.  Does anyone have any ideas, or better yet, patches?





Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.